/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateFaqCommand } from '../models';
import { CreateFaqTagCommand } from '../models';
import { CreateMediaCommand } from '../models';
import { FaqModel } from '../models';
import { FaqTagModel } from '../models';
import { FaqTagsModel } from '../models';
import { FaqsModel } from '../models';
import { MediaModel } from '../models';
import { MediaType } from '../models';
import { MediasModel } from '../models';
import { UpdateFaqCommand } from '../models';
import { UpdateMediaCommand } from '../models';
/**
 * FaqsApi - axios parameter creator
 * @export
 */
export declare const FaqsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete faq.
     * @param {string} faqId
     * @param {boolean} [forceDelete]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdDelete: (faqId: string, forceDelete?: boolean, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get faq.
     * @param {string} faqId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdGet: (faqId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all FaqMedias.
     * @param {string} faqId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasGet: (faqId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete FaqMedia
     * @param {string} faqId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdDelete: (faqId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get FaqMedia.
     * @param {string} faqId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdGet: (faqId: string, mediaId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update FaqMedia.
     * @param {string} faqId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdPut: (faqId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create FaqMedia.
     * @param {string} faqId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasPost: (faqId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update faq.
     * @param {string} faqId
     * @param {UpdateFaqCommand} [updateFaqCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdPut: (faqId: string, updateFaqCommand?: UpdateFaqCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Revalidate faq
     * @param {string} faqId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdRevalidatePost: (faqId: string, includeCurrent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary GetAll FaqTags.
     * @param {string} faqId
     * @param {string} [tagId]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsGet: (faqId: string, tagId?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create FaqTag.
     * @param {string} faqId
     * @param {CreateFaqTagCommand} [createFaqTagCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsPost: (faqId: string, createFaqTagCommand?: CreateFaqTagCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete FaqTag.
     * @param {string} faqId
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsTagIdDelete: (faqId: string, tagId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get FaqTag.
     * @param {string} faqId
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsTagIdGet: (faqId: string, tagId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get all Faqs.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [slug]
     * @param {string} [categoryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsGet: (id?: string, name?: string, slug?: string, categoryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create a faq.
     * @param {CreateFaqCommand} [createFaqCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsPost: (createFaqCommand?: CreateFaqCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get faq by slug.
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsSlugGet: (slug: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * FaqsApi - functional programming interface
 * @export
 */
export declare const FaqsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete faq.
     * @param {string} faqId
     * @param {boolean} [forceDelete]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdDelete(faqId: string, forceDelete?: boolean, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get faq.
     * @param {string} faqId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdGet(faqId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>>;
    /**
     *
     * @summary Get all FaqMedias.
     * @param {string} faqId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasGet(faqId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>>;
    /**
     *
     * @summary Delete FaqMedia
     * @param {string} faqId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdDelete(faqId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get FaqMedia.
     * @param {string} faqId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdGet(faqId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update FaqMedia.
     * @param {string} faqId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdPut(faqId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Create FaqMedia.
     * @param {string} faqId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasPost(faqId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>>;
    /**
     *
     * @summary Update faq.
     * @param {string} faqId
     * @param {UpdateFaqCommand} [updateFaqCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdPut(faqId: string, updateFaqCommand?: UpdateFaqCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>>;
    /**
     *
     * @summary Revalidate faq
     * @param {string} faqId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdRevalidatePost(faqId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary GetAll FaqTags.
     * @param {string} faqId
     * @param {string} [tagId]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsGet(faqId: string, tagId?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqTagsModel>>;
    /**
     *
     * @summary Create FaqTag.
     * @param {string} faqId
     * @param {CreateFaqTagCommand} [createFaqTagCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsPost(faqId: string, createFaqTagCommand?: CreateFaqTagCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqTagModel>>;
    /**
     *
     * @summary Delete FaqTag.
     * @param {string} faqId
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsTagIdDelete(faqId: string, tagId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get FaqTag.
     * @param {string} faqId
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsTagIdGet(faqId: string, tagId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqTagModel>>;
    /**
     *
     * @summary Get all Faqs.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [slug]
     * @param {string} [categoryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsGet(id?: string, name?: string, slug?: string, categoryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqsModel>>;
    /**
     *
     * @summary Create a faq.
     * @param {CreateFaqCommand} [createFaqCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsPost(createFaqCommand?: CreateFaqCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>>;
    /**
     *
     * @summary Get faq by slug.
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsSlugGet(slug: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>>;
};
/**
 * FaqsApi - factory interface
 * @export
 */
export declare const FaqsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete faq.
     * @param {string} faqId
     * @param {boolean} [forceDelete]
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdDelete(faqId: string, forceDelete?: boolean, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get faq.
     * @param {string} faqId
     * @param {string} [languageCode]
     * @param {boolean} [returnDefaultValue]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdGet(faqId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<FaqModel>;
    /**
     *
     * @summary Get all FaqMedias.
     * @param {string} faqId
     * @param {string} [id]
     * @param {MediaType} [mediaType]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasGet(faqId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel>;
    /**
     *
     * @summary Delete FaqMedia
     * @param {string} faqId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdDelete(faqId: string, mediaId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get FaqMedia.
     * @param {string} faqId
     * @param {string} mediaId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdGet(faqId: string, mediaId: string, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update FaqMedia.
     * @param {string} faqId
     * @param {string} mediaId
     * @param {UpdateMediaCommand} [updateMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasMediaIdPut(faqId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Create FaqMedia.
     * @param {string} faqId
     * @param {CreateMediaCommand} [createMediaCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdMediasPost(faqId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel>;
    /**
     *
     * @summary Update faq.
     * @param {string} faqId
     * @param {UpdateFaqCommand} [updateFaqCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdPut(faqId: string, updateFaqCommand?: UpdateFaqCommand, options?: any): AxiosPromise<FaqModel>;
    /**
     *
     * @summary Revalidate faq
     * @param {string} faqId
     * @param {boolean} [includeCurrent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdRevalidatePost(faqId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary GetAll FaqTags.
     * @param {string} faqId
     * @param {string} [tagId]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsGet(faqId: string, tagId?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FaqTagsModel>;
    /**
     *
     * @summary Create FaqTag.
     * @param {string} faqId
     * @param {CreateFaqTagCommand} [createFaqTagCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsPost(faqId: string, createFaqTagCommand?: CreateFaqTagCommand, options?: any): AxiosPromise<FaqTagModel>;
    /**
     *
     * @summary Delete FaqTag.
     * @param {string} faqId
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsTagIdDelete(faqId: string, tagId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get FaqTag.
     * @param {string} faqId
     * @param {string} tagId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsFaqIdTagsTagIdGet(faqId: string, tagId: string, options?: any): AxiosPromise<FaqTagModel>;
    /**
     *
     * @summary Get all Faqs.
     * @param {string} [id]
     * @param {string} [name]
     * @param {string} [slug]
     * @param {string} [categoryId]
     * @param {string} [hospitalId]
     * @param {string} [hospitalName]
     * @param {string} [languageCode]
     * @param {boolean} [showHidden]
     * @param {boolean} [returnDefaultValue]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsGet(id?: string, name?: string, slug?: string, categoryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FaqsModel>;
    /**
     *
     * @summary Create a faq.
     * @param {CreateFaqCommand} [createFaqCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsPost(createFaqCommand?: CreateFaqCommand, options?: any): AxiosPromise<FaqModel>;
    /**
     *
     * @summary Get faq by slug.
     * @param {string} slug
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FaqsSlugGet(slug: string, languageCode?: string, options?: any): AxiosPromise<FaqModel>;
};
/**
 * Request parameters for apiV1FaqsFaqIdDelete operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdDeleteRequest
 */
export interface FaqsApiApiV1FaqsFaqIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdDelete
     */
    readonly faqId: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdDelete
     */
    readonly forceDelete?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1FaqsFaqIdGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdGet
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdGet
     */
    readonly returnDefaultValue?: boolean;
}
/**
 * Request parameters for apiV1FaqsFaqIdMediasGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly id?: string;
    /**
     *
     * @type {MediaType}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly mediaType?: MediaType;
    /**
     *
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1FaqsFaqIdMediasMediaIdDelete operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdDelete
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdDelete
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1FaqsFaqIdMediasMediaIdGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdGet
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdGet
     */
    readonly mediaId: string;
}
/**
 * Request parameters for apiV1FaqsFaqIdMediasMediaIdPut operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdPut
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdPut
     */
    readonly mediaId: string;
    /**
     *
     * @type {UpdateMediaCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand;
}
/**
 * Request parameters for apiV1FaqsFaqIdMediasPost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasPostRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasPostRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasPost
     */
    readonly faqId: string;
    /**
     *
     * @type {CreateMediaCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand;
}
/**
 * Request parameters for apiV1FaqsFaqIdPut operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdPutRequest
 */
export interface FaqsApiApiV1FaqsFaqIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdPut
     */
    readonly faqId: string;
    /**
     *
     * @type {UpdateFaqCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdPut
     */
    readonly updateFaqCommand?: UpdateFaqCommand;
}
/**
 * Request parameters for apiV1FaqsFaqIdRevalidatePost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdRevalidatePostRequest
 */
export interface FaqsApiApiV1FaqsFaqIdRevalidatePostRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdRevalidatePost
     */
    readonly faqId: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdRevalidatePost
     */
    readonly includeCurrent?: boolean;
}
/**
 * Request parameters for apiV1FaqsFaqIdTagsGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly tagId?: string;
    /**
     *
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1FaqsFaqIdTagsPost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsPostRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsPostRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsPost
     */
    readonly faqId: string;
    /**
     *
     * @type {CreateFaqTagCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsPost
     */
    readonly createFaqTagCommand?: CreateFaqTagCommand;
}
/**
 * Request parameters for apiV1FaqsFaqIdTagsTagIdDelete operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdDelete
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdDelete
     */
    readonly tagId: string;
}
/**
 * Request parameters for apiV1FaqsFaqIdTagsTagIdGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdGet
     */
    readonly faqId: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdGet
     */
    readonly tagId: string;
}
/**
 * Request parameters for apiV1FaqsGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsGetRequest
 */
export interface FaqsApiApiV1FaqsGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly slug?: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly categoryId?: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly hospitalName?: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly returnDefaultValue?: boolean;
    /**
     *
     * @type {number}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1FaqsPost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsPostRequest
 */
export interface FaqsApiApiV1FaqsPostRequest {
    /**
     *
     * @type {CreateFaqCommand}
     * @memberof FaqsApiApiV1FaqsPost
     */
    readonly createFaqCommand?: CreateFaqCommand;
}
/**
 * Request parameters for apiV1FaqsSlugGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsSlugGetRequest
 */
export interface FaqsApiApiV1FaqsSlugGetRequest {
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsSlugGet
     */
    readonly slug: string;
    /**
     *
     * @type {string}
     * @memberof FaqsApiApiV1FaqsSlugGet
     */
    readonly languageCode?: string;
}
/**
 * FaqsApi - object-oriented interface
 * @export
 * @class FaqsApi
 * @extends {BaseAPI}
 */
export declare class FaqsApi extends BaseAPI {
    /**
     *
     * @summary Delete faq.
     * @param {FaqsApiApiV1FaqsFaqIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdDelete(requestParameters: FaqsApiApiV1FaqsFaqIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get faq.
     * @param {FaqsApiApiV1FaqsFaqIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdGet(requestParameters: FaqsApiApiV1FaqsFaqIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqModel, any>>;
    /**
     *
     * @summary Get all FaqMedias.
     * @param {FaqsApiApiV1FaqsFaqIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdMediasGet(requestParameters: FaqsApiApiV1FaqsFaqIdMediasGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediasModel, any>>;
    /**
     *
     * @summary Delete FaqMedia
     * @param {FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdMediasMediaIdDelete(requestParameters: FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get FaqMedia.
     * @param {FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdMediasMediaIdGet(requestParameters: FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update FaqMedia.
     * @param {FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdMediasMediaIdPut(requestParameters: FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Create FaqMedia.
     * @param {FaqsApiApiV1FaqsFaqIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdMediasPost(requestParameters: FaqsApiApiV1FaqsFaqIdMediasPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<MediaModel, any>>;
    /**
     *
     * @summary Update faq.
     * @param {FaqsApiApiV1FaqsFaqIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdPut(requestParameters: FaqsApiApiV1FaqsFaqIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqModel, any>>;
    /**
     *
     * @summary Revalidate faq
     * @param {FaqsApiApiV1FaqsFaqIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdRevalidatePost(requestParameters: FaqsApiApiV1FaqsFaqIdRevalidatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary GetAll FaqTags.
     * @param {FaqsApiApiV1FaqsFaqIdTagsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdTagsGet(requestParameters: FaqsApiApiV1FaqsFaqIdTagsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqTagsModel, any>>;
    /**
     *
     * @summary Create FaqTag.
     * @param {FaqsApiApiV1FaqsFaqIdTagsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdTagsPost(requestParameters: FaqsApiApiV1FaqsFaqIdTagsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqTagModel, any>>;
    /**
     *
     * @summary Delete FaqTag.
     * @param {FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdTagsTagIdDelete(requestParameters: FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get FaqTag.
     * @param {FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsFaqIdTagsTagIdGet(requestParameters: FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqTagModel, any>>;
    /**
     *
     * @summary Get all Faqs.
     * @param {FaqsApiApiV1FaqsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsGet(requestParameters?: FaqsApiApiV1FaqsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqsModel, any>>;
    /**
     *
     * @summary Create a faq.
     * @param {FaqsApiApiV1FaqsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsPost(requestParameters?: FaqsApiApiV1FaqsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqModel, any>>;
    /**
     *
     * @summary Get faq by slug.
     * @param {FaqsApiApiV1FaqsSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    apiV1FaqsSlugGet(requestParameters: FaqsApiApiV1FaqsSlugGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FaqModel, any>>;
}
//# sourceMappingURL=faqs-api.d.ts.map