/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { FormTemplateAffiliationsModel } from '../models';
import { FormTemplateModel } from '../models';
import { FormTemplatePlatform } from '../models';
import { FormTemplateStatus } from '../models';
import { FormTemplateType } from '../models';
import { FormTemplatesModel } from '../models';
import { SaveFormTemplateCommand } from '../models';
import { SetHospitalIntoFormTemplateCommand } from '../models';
import { TranslateFormTemplateCommand } from '../models';
import { TranslationBatchResultModel } from '../models';
/**
 * FormTemplatesApi - axios parameter creator
 * @export
 */
export declare const FormTemplatesApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete formTemplate
     * @param {string} formTemplateId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdDelete: (formTemplateId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get formTemplateAffilitions
     * @param {string} formTemplateId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet: (formTemplateId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get formTemplate
     * @param {string} formTemplateId
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdGet: (formTemplateId: string, languageCode?: string, hospitalId?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Remove hospital from formTemplateAffiliations
     * @param {string} formTemplateId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete: (formTemplateId: string, hospitalId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Add hospital into formTemplateAffiliations.
     * @param {string} formTemplateId
     * @param {string} hospitalId
     * @param {SetHospitalIntoFormTemplateCommand} [setHospitalIntoFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost: (formTemplateId: string, hospitalId: string, setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update formTemplate
     * @param {string} formTemplateId
     * @param {SaveFormTemplateCommand} [saveFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdPut: (formTemplateId: string, saveFormTemplateCommand?: SaveFormTemplateCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate formTemplate
     * @param {string} formTemplateId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdReactivatePut: (formTemplateId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Translate formTemplate
     * @param {string} formTemplateId
     * @param {TranslateFormTemplateCommand} [translateFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdTranslatePost: (formTemplateId: string, translateFormTemplateCommand?: TranslateFormTemplateCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get formTemplates
     * @param {string} [languageCode]
     * @param {string} [name]
     * @param {string} [hospitalId]
     * @param {FormTemplatePlatform} [platform]
     * @param {FormTemplateType} [formTemplateType]
     * @param {FormTemplateStatus} [status]
     * @param {boolean} [isShared]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesGet: (languageCode?: string, name?: string, hospitalId?: string, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormTemplateStatus, isShared?: boolean, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create formTemplate
     * @param {SaveFormTemplateCommand} [saveFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesPost: (saveFormTemplateCommand?: SaveFormTemplateCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * FormTemplatesApi - functional programming interface
 * @export
 */
export declare const FormTemplatesApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Delete formTemplate
     * @param {string} formTemplateId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdDelete(formTemplateId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get formTemplateAffilitions
     * @param {string} formTemplateId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(formTemplateId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateAffiliationsModel>>;
    /**
     *
     * @summary Get formTemplate
     * @param {string} formTemplateId
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdGet(formTemplateId: string, languageCode?: string, hospitalId?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateModel>>;
    /**
     *
     * @summary Remove hospital from formTemplateAffiliations
     * @param {string} formTemplateId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(formTemplateId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Add hospital into formTemplateAffiliations.
     * @param {string} formTemplateId
     * @param {string} hospitalId
     * @param {SetHospitalIntoFormTemplateCommand} [setHospitalIntoFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(formTemplateId: string, hospitalId: string, setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Update formTemplate
     * @param {string} formTemplateId
     * @param {SaveFormTemplateCommand} [saveFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdPut(formTemplateId: string, saveFormTemplateCommand?: SaveFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateModel>>;
    /**
     *
     * @summary Reactivate formTemplate
     * @param {string} formTemplateId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdReactivatePut(formTemplateId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Translate formTemplate
     * @param {string} formTemplateId
     * @param {TranslateFormTemplateCommand} [translateFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdTranslatePost(formTemplateId: string, translateFormTemplateCommand?: TranslateFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TranslationBatchResultModel>>;
    /**
     *
     * @summary Get formTemplates
     * @param {string} [languageCode]
     * @param {string} [name]
     * @param {string} [hospitalId]
     * @param {FormTemplatePlatform} [platform]
     * @param {FormTemplateType} [formTemplateType]
     * @param {FormTemplateStatus} [status]
     * @param {boolean} [isShared]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesGet(languageCode?: string, name?: string, hospitalId?: string, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormTemplateStatus, isShared?: boolean, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplatesModel>>;
    /**
     *
     * @summary Create formTemplate
     * @param {SaveFormTemplateCommand} [saveFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesPost(saveFormTemplateCommand?: SaveFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateModel>>;
};
/**
 * FormTemplatesApi - factory interface
 * @export
 */
export declare const FormTemplatesApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Delete formTemplate
     * @param {string} formTemplateId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdDelete(formTemplateId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get formTemplateAffilitions
     * @param {string} formTemplateId
     * @param {string} [languageCode]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(formTemplateId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FormTemplateAffiliationsModel>;
    /**
     *
     * @summary Get formTemplate
     * @param {string} formTemplateId
     * @param {string} [languageCode]
     * @param {string} [hospitalId]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdGet(formTemplateId: string, languageCode?: string, hospitalId?: string, options?: any): AxiosPromise<FormTemplateModel>;
    /**
     *
     * @summary Remove hospital from formTemplateAffiliations
     * @param {string} formTemplateId
     * @param {string} hospitalId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(formTemplateId: string, hospitalId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Add hospital into formTemplateAffiliations.
     * @param {string} formTemplateId
     * @param {string} hospitalId
     * @param {SetHospitalIntoFormTemplateCommand} [setHospitalIntoFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(formTemplateId: string, hospitalId: string, setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Update formTemplate
     * @param {string} formTemplateId
     * @param {SaveFormTemplateCommand} [saveFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdPut(formTemplateId: string, saveFormTemplateCommand?: SaveFormTemplateCommand, options?: any): AxiosPromise<FormTemplateModel>;
    /**
     *
     * @summary Reactivate formTemplate
     * @param {string} formTemplateId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdReactivatePut(formTemplateId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Translate formTemplate
     * @param {string} formTemplateId
     * @param {TranslateFormTemplateCommand} [translateFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesFormTemplateIdTranslatePost(formTemplateId: string, translateFormTemplateCommand?: TranslateFormTemplateCommand, options?: any): AxiosPromise<TranslationBatchResultModel>;
    /**
     *
     * @summary Get formTemplates
     * @param {string} [languageCode]
     * @param {string} [name]
     * @param {string} [hospitalId]
     * @param {FormTemplatePlatform} [platform]
     * @param {FormTemplateType} [formTemplateType]
     * @param {FormTemplateStatus} [status]
     * @param {boolean} [isShared]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesGet(languageCode?: string, name?: string, hospitalId?: string, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormTemplateStatus, isShared?: boolean, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FormTemplatesModel>;
    /**
     *
     * @summary Create formTemplate
     * @param {SaveFormTemplateCommand} [saveFormTemplateCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1FormtemplatesPost(saveFormTemplateCommand?: SaveFormTemplateCommand, options?: any): AxiosPromise<FormTemplateModel>;
};
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdDelete operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdDelete
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {boolean}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdGet operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdGet
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdGet
     */
    readonly hospitalId?: string;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost
     */
    readonly hospitalId: string;
    /**
     *
     * @type {SetHospitalIntoFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost
     */
    readonly setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdPut operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdPut
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {SaveFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdPut
     */
    readonly saveFormTemplateCommand?: SaveFormTemplateCommand;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdReactivatePut operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePut
     */
    readonly formTemplateId: string;
}
/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdTranslatePost operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePost
     */
    readonly formTemplateId: string;
    /**
     *
     * @type {TranslateFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePost
     */
    readonly translateFormTemplateCommand?: TranslateFormTemplateCommand;
}
/**
 * Request parameters for apiV1FormtemplatesGet operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesGetRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesGetRequest {
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {FormTemplatePlatform}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly platform?: FormTemplatePlatform;
    /**
     *
     * @type {FormTemplateType}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly formTemplateType?: FormTemplateType;
    /**
     *
     * @type {FormTemplateStatus}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly status?: FormTemplateStatus;
    /**
     *
     * @type {boolean}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly isShared?: boolean;
    /**
     *
     * @type {boolean}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1FormtemplatesPost operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesPostRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesPostRequest {
    /**
     *
     * @type {SaveFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesPost
     */
    readonly saveFormTemplateCommand?: SaveFormTemplateCommand;
}
/**
 * FormTemplatesApi - object-oriented interface
 * @export
 * @class FormTemplatesApi
 * @extends {BaseAPI}
 */
export declare class FormTemplatesApi extends BaseAPI {
    /**
     *
     * @summary Delete formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdDelete(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get formTemplateAffilitions
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormTemplateAffiliationsModel, any>>;
    /**
     *
     * @summary Get formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdGet(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormTemplateModel, any>>;
    /**
     *
     * @summary Remove hospital from formTemplateAffiliations
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Add hospital into formTemplateAffiliations.
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Update formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdPut(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormTemplateModel, any>>;
    /**
     *
     * @summary Reactivate formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdReactivatePut(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Translate formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesFormTemplateIdTranslatePost(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<TranslationBatchResultModel, any>>;
    /**
     *
     * @summary Get formTemplates
     * @param {FormTemplatesApiApiV1FormtemplatesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesGet(requestParameters?: FormTemplatesApiApiV1FormtemplatesGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormTemplatesModel, any>>;
    /**
     *
     * @summary Create formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    apiV1FormtemplatesPost(requestParameters?: FormTemplatesApiApiV1FormtemplatesPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<FormTemplateModel, any>>;
}
//# sourceMappingURL=form-templates-api.d.ts.map