/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { CreateHospitalGroupCommand } from '../models';
import { HospitalGroupModel } from '../models';
import { HospitalGroupsModel } from '../models';
import { UpdateHospitalGroupCommand } from '../models';
/**
 * HospitalGroupsApi - axios parameter creator
 * @export
 */
export declare const HospitalGroupsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get hospitalGroups
     * @param {string} [hospitalGroupId]
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {string} [name]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsGet: (hospitalGroupId?: string, hospitalId?: string, languageCode?: string, name?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete hospitalGroup
     * @param {string} hospitalGroupId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdDelete: (hospitalGroupId: string, isPermanent?: boolean, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get hospitalGroup
     * @param {string} hospitalGroupId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdGet: (hospitalGroupId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Update hospitalGroup
     * @param {string} hospitalGroupId
     * @param {UpdateHospitalGroupCommand} [updateHospitalGroupCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdPut: (hospitalGroupId: string, updateHospitalGroupCommand?: UpdateHospitalGroupCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Reactivate hospitalGroup
     * @param {string} hospitalGroupId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdReactivatePut: (hospitalGroupId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Create hospitalGroup
     * @param {CreateHospitalGroupCommand} [createHospitalGroupCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsPost: (createHospitalGroupCommand?: CreateHospitalGroupCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * HospitalGroupsApi - functional programming interface
 * @export
 */
export declare const HospitalGroupsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get hospitalGroups
     * @param {string} [hospitalGroupId]
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {string} [name]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsGet(hospitalGroupId?: string, hospitalId?: string, languageCode?: string, name?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupsModel>>;
    /**
     *
     * @summary Delete hospitalGroup
     * @param {string} hospitalGroupId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdDelete(hospitalGroupId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get hospitalGroup
     * @param {string} hospitalGroupId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdGet(hospitalGroupId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupModel>>;
    /**
     *
     * @summary Update hospitalGroup
     * @param {string} hospitalGroupId
     * @param {UpdateHospitalGroupCommand} [updateHospitalGroupCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdPut(hospitalGroupId: string, updateHospitalGroupCommand?: UpdateHospitalGroupCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupModel>>;
    /**
     *
     * @summary Reactivate hospitalGroup
     * @param {string} hospitalGroupId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdReactivatePut(hospitalGroupId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Create hospitalGroup
     * @param {CreateHospitalGroupCommand} [createHospitalGroupCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsPost(createHospitalGroupCommand?: CreateHospitalGroupCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<HospitalGroupModel>>;
};
/**
 * HospitalGroupsApi - factory interface
 * @export
 */
export declare const HospitalGroupsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get hospitalGroups
     * @param {string} [hospitalGroupId]
     * @param {string} [hospitalId]
     * @param {string} [languageCode]
     * @param {string} [name]
     * @param {boolean} [showHidden]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsGet(hospitalGroupId?: string, hospitalId?: string, languageCode?: string, name?: string, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<HospitalGroupsModel>;
    /**
     *
     * @summary Delete hospitalGroup
     * @param {string} hospitalGroupId
     * @param {boolean} [isPermanent]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdDelete(hospitalGroupId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get hospitalGroup
     * @param {string} hospitalGroupId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdGet(hospitalGroupId: string, languageCode?: string, options?: any): AxiosPromise<HospitalGroupModel>;
    /**
     *
     * @summary Update hospitalGroup
     * @param {string} hospitalGroupId
     * @param {UpdateHospitalGroupCommand} [updateHospitalGroupCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdPut(hospitalGroupId: string, updateHospitalGroupCommand?: UpdateHospitalGroupCommand, options?: any): AxiosPromise<HospitalGroupModel>;
    /**
     *
     * @summary Reactivate hospitalGroup
     * @param {string} hospitalGroupId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsHospitalGroupIdReactivatePut(hospitalGroupId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Create hospitalGroup
     * @param {CreateHospitalGroupCommand} [createHospitalGroupCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1HospitalgroupsPost(createHospitalGroupCommand?: CreateHospitalGroupCommand, options?: any): AxiosPromise<HospitalGroupModel>;
};
/**
 * Request parameters for apiV1HospitalgroupsGet operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsGetRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsGetRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly hospitalGroupId?: string;
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly name?: string;
    /**
     *
     * @type {boolean}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly showHidden?: boolean;
    /**
     *
     * @type {number}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdDelete operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDelete
     */
    readonly hospitalGroupId: string;
    /**
     *
     * @type {boolean}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDelete
     */
    readonly isPermanent?: boolean;
}
/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdGet operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGet
     */
    readonly hospitalGroupId: string;
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGet
     */
    readonly languageCode?: string;
}
/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdPut operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPut
     */
    readonly hospitalGroupId: string;
    /**
     *
     * @type {UpdateHospitalGroupCommand}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPut
     */
    readonly updateHospitalGroupCommand?: UpdateHospitalGroupCommand;
}
/**
 * Request parameters for apiV1HospitalgroupsHospitalGroupIdReactivatePut operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest {
    /**
     *
     * @type {string}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePut
     */
    readonly hospitalGroupId: string;
}
/**
 * Request parameters for apiV1HospitalgroupsPost operation in HospitalGroupsApi.
 * @export
 * @interface HospitalGroupsApiApiV1HospitalgroupsPostRequest
 */
export interface HospitalGroupsApiApiV1HospitalgroupsPostRequest {
    /**
     *
     * @type {CreateHospitalGroupCommand}
     * @memberof HospitalGroupsApiApiV1HospitalgroupsPost
     */
    readonly createHospitalGroupCommand?: CreateHospitalGroupCommand;
}
/**
 * HospitalGroupsApi - object-oriented interface
 * @export
 * @class HospitalGroupsApi
 * @extends {BaseAPI}
 */
export declare class HospitalGroupsApi extends BaseAPI {
    /**
     *
     * @summary Get hospitalGroups
     * @param {HospitalGroupsApiApiV1HospitalgroupsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    apiV1HospitalgroupsGet(requestParameters?: HospitalGroupsApiApiV1HospitalgroupsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalGroupsModel, any>>;
    /**
     *
     * @summary Delete hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    apiV1HospitalgroupsHospitalGroupIdDelete(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    apiV1HospitalgroupsHospitalGroupIdGet(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalGroupModel, any>>;
    /**
     *
     * @summary Update hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    apiV1HospitalgroupsHospitalGroupIdPut(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdPutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalGroupModel, any>>;
    /**
     *
     * @summary Reactivate hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    apiV1HospitalgroupsHospitalGroupIdReactivatePut(requestParameters: HospitalGroupsApiApiV1HospitalgroupsHospitalGroupIdReactivatePutRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Create hospitalGroup
     * @param {HospitalGroupsApiApiV1HospitalgroupsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof HospitalGroupsApi
     */
    apiV1HospitalgroupsPost(requestParameters?: HospitalGroupsApiApiV1HospitalgroupsPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<HospitalGroupModel, any>>;
}
//# sourceMappingURL=hospital-groups-api.d.ts.map