/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */
import { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
import { RequestArgs, BaseAPI } from '../base';
import { PeriodUnits } from '../models';
import { SendEmailCommand } from '../models';
import { SurveyResultModel } from '../models';
import { SurveyResultsModel } from '../models';
/**
 * SurveyResultsApi - axios parameter creator
 * @export
 */
export declare const SurveyResultsApiAxiosParamCreator: (configuration?: Configuration) => {
    /**
     *
     * @summary Get survey results
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [surveyFormId]
     * @param {string} [name]
     * @param {string} [languageCode]
     * @param {PeriodUnits} [periodUnit]
     * @param {Date} [startDateTime]
     * @param {Date} [endDateTime]
     * @param {boolean} [isExternal]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsGet: (id?: string, hospitalId?: string, surveyFormId?: string, name?: string, languageCode?: string, periodUnit?: PeriodUnits, startDateTime?: Date, endDateTime?: Date, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Send manual notification of target SurveyResult
     * @param {SendEmailCommand} [sendEmailCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSendemailPost: (sendEmailCommand?: SendEmailCommand, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Delete survey result
     * @param {string} surveyResultId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSurveyResultIdDelete: (surveyResultId: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
    /**
     *
     * @summary Get survey result by Id
     * @param {string} surveyResultId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSurveyResultIdGet: (surveyResultId: string, languageCode?: string, options?: AxiosRequestConfig) => Promise<RequestArgs>;
};
/**
 * SurveyResultsApi - functional programming interface
 * @export
 */
export declare const SurveyResultsApiFp: (configuration?: Configuration) => {
    /**
     *
     * @summary Get survey results
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [surveyFormId]
     * @param {string} [name]
     * @param {string} [languageCode]
     * @param {PeriodUnits} [periodUnit]
     * @param {Date} [startDateTime]
     * @param {Date} [endDateTime]
     * @param {boolean} [isExternal]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsGet(id?: string, hospitalId?: string, surveyFormId?: string, name?: string, languageCode?: string, periodUnit?: PeriodUnits, startDateTime?: Date, endDateTime?: Date, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyResultsModel>>;
    /**
     *
     * @summary Send manual notification of target SurveyResult
     * @param {SendEmailCommand} [sendEmailCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSendemailPost(sendEmailCommand?: SendEmailCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Delete survey result
     * @param {string} surveyResultId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSurveyResultIdDelete(surveyResultId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>>;
    /**
     *
     * @summary Get survey result by Id
     * @param {string} surveyResultId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSurveyResultIdGet(surveyResultId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<SurveyResultModel>>;
};
/**
 * SurveyResultsApi - factory interface
 * @export
 */
export declare const SurveyResultsApiFactory: (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) => {
    /**
     *
     * @summary Get survey results
     * @param {string} [id]
     * @param {string} [hospitalId]
     * @param {string} [surveyFormId]
     * @param {string} [name]
     * @param {string} [languageCode]
     * @param {PeriodUnits} [periodUnit]
     * @param {Date} [startDateTime]
     * @param {Date} [endDateTime]
     * @param {boolean} [isExternal]
     * @param {number} [page]
     * @param {number} [limit]
     * @param {Date} [lastRetrieved]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsGet(id?: string, hospitalId?: string, surveyFormId?: string, name?: string, languageCode?: string, periodUnit?: PeriodUnits, startDateTime?: Date, endDateTime?: Date, isExternal?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<SurveyResultsModel>;
    /**
     *
     * @summary Send manual notification of target SurveyResult
     * @param {SendEmailCommand} [sendEmailCommand]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSendemailPost(sendEmailCommand?: SendEmailCommand, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Delete survey result
     * @param {string} surveyResultId
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSurveyResultIdDelete(surveyResultId: string, options?: any): AxiosPromise<boolean>;
    /**
     *
     * @summary Get survey result by Id
     * @param {string} surveyResultId
     * @param {string} [languageCode]
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     */
    apiV1SurveyresultsSurveyResultIdGet(surveyResultId: string, languageCode?: string, options?: any): AxiosPromise<SurveyResultModel>;
};
/**
 * Request parameters for apiV1SurveyresultsGet operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsGetRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsGetRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly id?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly hospitalId?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly surveyFormId?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly name?: string;
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly languageCode?: string;
    /**
     *
     * @type {PeriodUnits}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly periodUnit?: PeriodUnits;
    /**
     *
     * @type {Date}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly startDateTime?: Date;
    /**
     *
     * @type {Date}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly endDateTime?: Date;
    /**
     *
     * @type {boolean}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly isExternal?: boolean;
    /**
     *
     * @type {number}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly page?: number;
    /**
     *
     * @type {number}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly limit?: number;
    /**
     *
     * @type {Date}
     * @memberof SurveyResultsApiApiV1SurveyresultsGet
     */
    readonly lastRetrieved?: Date;
}
/**
 * Request parameters for apiV1SurveyresultsSendemailPost operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsSendemailPostRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsSendemailPostRequest {
    /**
     *
     * @type {SendEmailCommand}
     * @memberof SurveyResultsApiApiV1SurveyresultsSendemailPost
     */
    readonly sendEmailCommand?: SendEmailCommand;
}
/**
 * Request parameters for apiV1SurveyresultsSurveyResultIdDelete operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsSurveyResultIdDelete
     */
    readonly surveyResultId: string;
}
/**
 * Request parameters for apiV1SurveyresultsSurveyResultIdGet operation in SurveyResultsApi.
 * @export
 * @interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest
 */
export interface SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest {
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsSurveyResultIdGet
     */
    readonly surveyResultId: string;
    /**
     *
     * @type {string}
     * @memberof SurveyResultsApiApiV1SurveyresultsSurveyResultIdGet
     */
    readonly languageCode?: string;
}
/**
 * SurveyResultsApi - object-oriented interface
 * @export
 * @class SurveyResultsApi
 * @extends {BaseAPI}
 */
export declare class SurveyResultsApi extends BaseAPI {
    /**
     *
     * @summary Get survey results
     * @param {SurveyResultsApiApiV1SurveyresultsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    apiV1SurveyresultsGet(requestParameters?: SurveyResultsApiApiV1SurveyresultsGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyResultsModel, any>>;
    /**
     *
     * @summary Send manual notification of target SurveyResult
     * @param {SurveyResultsApiApiV1SurveyresultsSendemailPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    apiV1SurveyresultsSendemailPost(requestParameters?: SurveyResultsApiApiV1SurveyresultsSendemailPostRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Delete survey result
     * @param {SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    apiV1SurveyresultsSurveyResultIdDelete(requestParameters: SurveyResultsApiApiV1SurveyresultsSurveyResultIdDeleteRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<boolean, any>>;
    /**
     *
     * @summary Get survey result by Id
     * @param {SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof SurveyResultsApi
     */
    apiV1SurveyresultsSurveyResultIdGet(requestParameters: SurveyResultsApiApiV1SurveyresultsSurveyResultIdGetRequest, options?: AxiosRequestConfig): Promise<import("axios").AxiosResponse<SurveyResultModel, any>>;
}
//# sourceMappingURL=survey-results-api.d.ts.map