/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { AppVersionModel } from '../models';
// @ts-ignore
import { AppVersionsModel } from '../models';
// @ts-ignore
import { CreateAppVersionCommand } from '../models';
// @ts-ignore
import { Platform } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateAppVersionCommand } from '../models';
/**
 * AppVersionApi - axios parameter creator
 * @export
 */
export const AppVersionApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @param {Platform} [platform] 
         * @param {string} [latestVersion] 
         * @param {string} [minimumVersion] 
         * @param {Date} [committedDate] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionGet: async (platform?: Platform, latestVersion?: string, minimumVersion?: string, committedDate?: Date, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/appversion`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (platform !== undefined) {
                localVarQueryParameter['Platform'] = platform;
            }

            if (latestVersion !== undefined) {
                localVarQueryParameter['LatestVersion'] = latestVersion;
            }

            if (minimumVersion !== undefined) {
                localVarQueryParameter['MinimumVersion'] = minimumVersion;
            }

            if (committedDate !== undefined) {
                localVarQueryParameter['CommittedDate'] = (committedDate as any instanceof Date) ?
                    (committedDate as any).toISOString() :
                    committedDate;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPlatformDelete: async (platform: Platform, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'platform' is not null or undefined
            assertParamExists('apiV1AppversionPlatformDelete', 'platform', platform)
            const localVarPath = `/api/v1/appversion/{platform}`
                .replace(`{${"platform"}}`, encodeURIComponent(String(platform)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPlatformGet: async (platform: Platform, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'platform' is not null or undefined
            assertParamExists('apiV1AppversionPlatformGet', 'platform', platform)
            const localVarPath = `/api/v1/appversion/{platform}`
                .replace(`{${"platform"}}`, encodeURIComponent(String(platform)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {UpdateAppVersionCommand} [updateAppVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPlatformPut: async (platform: Platform, updateAppVersionCommand?: UpdateAppVersionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'platform' is not null or undefined
            assertParamExists('apiV1AppversionPlatformPut', 'platform', platform)
            const localVarPath = `/api/v1/appversion/{platform}`
                .replace(`{${"platform"}}`, encodeURIComponent(String(platform)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateAppVersionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @param {CreateAppVersionCommand} [createAppVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPost: async (createAppVersionCommand?: CreateAppVersionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/appversion`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createAppVersionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * AppVersionApi - functional programming interface
 * @export
 */
export const AppVersionApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = AppVersionApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @param {Platform} [platform] 
         * @param {string} [latestVersion] 
         * @param {string} [minimumVersion] 
         * @param {Date} [committedDate] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AppversionGet(platform?: Platform, latestVersion?: string, minimumVersion?: string, committedDate?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppVersionsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AppversionGet(platform, latestVersion, minimumVersion, committedDate, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AppversionPlatformDelete(platform: Platform, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AppversionPlatformDelete(platform, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AppversionPlatformGet(platform: Platform, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AppversionPlatformGet(platform, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {UpdateAppVersionCommand} [updateAppVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AppversionPlatformPut(platform: Platform, updateAppVersionCommand?: UpdateAppVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AppversionPlatformPut(platform, updateAppVersionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @param {CreateAppVersionCommand} [createAppVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1AppversionPost(createAppVersionCommand?: CreateAppVersionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<AppVersionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1AppversionPost(createAppVersionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * AppVersionApi - factory interface
 * @export
 */
export const AppVersionApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = AppVersionApiFp(configuration)
    return {
        /**
         * 
         * @param {Platform} [platform] 
         * @param {string} [latestVersion] 
         * @param {string} [minimumVersion] 
         * @param {Date} [committedDate] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionGet(platform?: Platform, latestVersion?: string, minimumVersion?: string, committedDate?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<AppVersionsModel> {
            return localVarFp.apiV1AppversionGet(platform, latestVersion, minimumVersion, committedDate, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPlatformDelete(platform: Platform, options?: any): AxiosPromise<AppVersionModel> {
            return localVarFp.apiV1AppversionPlatformDelete(platform, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPlatformGet(platform: Platform, options?: any): AxiosPromise<AppVersionModel> {
            return localVarFp.apiV1AppversionPlatformGet(platform, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {Platform} platform 
         * @param {UpdateAppVersionCommand} [updateAppVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPlatformPut(platform: Platform, updateAppVersionCommand?: UpdateAppVersionCommand, options?: any): AxiosPromise<AppVersionModel> {
            return localVarFp.apiV1AppversionPlatformPut(platform, updateAppVersionCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @param {CreateAppVersionCommand} [createAppVersionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1AppversionPost(createAppVersionCommand?: CreateAppVersionCommand, options?: any): AxiosPromise<AppVersionModel> {
            return localVarFp.apiV1AppversionPost(createAppVersionCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1AppversionGet operation in AppVersionApi.
 * @export
 * @interface AppVersionApiApiV1AppversionGetRequest
 */
export interface AppVersionApiApiV1AppversionGetRequest {
    /**
     * 
     * @type {Platform}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly platform?: Platform

    /**
     * 
     * @type {string}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly latestVersion?: string

    /**
     * 
     * @type {string}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly minimumVersion?: string

    /**
     * 
     * @type {Date}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly committedDate?: Date

    /**
     * 
     * @type {number}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof AppVersionApiApiV1AppversionGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1AppversionPlatformDelete operation in AppVersionApi.
 * @export
 * @interface AppVersionApiApiV1AppversionPlatformDeleteRequest
 */
export interface AppVersionApiApiV1AppversionPlatformDeleteRequest {
    /**
     * 
     * @type {Platform}
     * @memberof AppVersionApiApiV1AppversionPlatformDelete
     */
    readonly platform: Platform
}

/**
 * Request parameters for apiV1AppversionPlatformGet operation in AppVersionApi.
 * @export
 * @interface AppVersionApiApiV1AppversionPlatformGetRequest
 */
export interface AppVersionApiApiV1AppversionPlatformGetRequest {
    /**
     * 
     * @type {Platform}
     * @memberof AppVersionApiApiV1AppversionPlatformGet
     */
    readonly platform: Platform
}

/**
 * Request parameters for apiV1AppversionPlatformPut operation in AppVersionApi.
 * @export
 * @interface AppVersionApiApiV1AppversionPlatformPutRequest
 */
export interface AppVersionApiApiV1AppversionPlatformPutRequest {
    /**
     * 
     * @type {Platform}
     * @memberof AppVersionApiApiV1AppversionPlatformPut
     */
    readonly platform: Platform

    /**
     * 
     * @type {UpdateAppVersionCommand}
     * @memberof AppVersionApiApiV1AppversionPlatformPut
     */
    readonly updateAppVersionCommand?: UpdateAppVersionCommand
}

/**
 * Request parameters for apiV1AppversionPost operation in AppVersionApi.
 * @export
 * @interface AppVersionApiApiV1AppversionPostRequest
 */
export interface AppVersionApiApiV1AppversionPostRequest {
    /**
     * 
     * @type {CreateAppVersionCommand}
     * @memberof AppVersionApiApiV1AppversionPost
     */
    readonly createAppVersionCommand?: CreateAppVersionCommand
}

/**
 * AppVersionApi - object-oriented interface
 * @export
 * @class AppVersionApi
 * @extends {BaseAPI}
 */
export class AppVersionApi extends BaseAPI {
    /**
     * 
     * @param {AppVersionApiApiV1AppversionGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AppVersionApi
     */
    public apiV1AppversionGet(requestParameters: AppVersionApiApiV1AppversionGetRequest = {}, options?: AxiosRequestConfig) {
        return AppVersionApiFp(this.configuration).apiV1AppversionGet(requestParameters.platform, requestParameters.latestVersion, requestParameters.minimumVersion, requestParameters.committedDate, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {AppVersionApiApiV1AppversionPlatformDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AppVersionApi
     */
    public apiV1AppversionPlatformDelete(requestParameters: AppVersionApiApiV1AppversionPlatformDeleteRequest, options?: AxiosRequestConfig) {
        return AppVersionApiFp(this.configuration).apiV1AppversionPlatformDelete(requestParameters.platform, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {AppVersionApiApiV1AppversionPlatformGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AppVersionApi
     */
    public apiV1AppversionPlatformGet(requestParameters: AppVersionApiApiV1AppversionPlatformGetRequest, options?: AxiosRequestConfig) {
        return AppVersionApiFp(this.configuration).apiV1AppversionPlatformGet(requestParameters.platform, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {AppVersionApiApiV1AppversionPlatformPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AppVersionApi
     */
    public apiV1AppversionPlatformPut(requestParameters: AppVersionApiApiV1AppversionPlatformPutRequest, options?: AxiosRequestConfig) {
        return AppVersionApiFp(this.configuration).apiV1AppversionPlatformPut(requestParameters.platform, requestParameters.updateAppVersionCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @param {AppVersionApiApiV1AppversionPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof AppVersionApi
     */
    public apiV1AppversionPost(requestParameters: AppVersionApiApiV1AppversionPostRequest = {}, options?: AxiosRequestConfig) {
        return AppVersionApiFp(this.configuration).apiV1AppversionPost(requestParameters.createAppVersionCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
