/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { EmailRecordModel } from '../models';
// @ts-ignore
import { EmailRecordsModel } from '../models';
// @ts-ignore
import { EmailStatus } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { TestEmailModel } from '../models';
// @ts-ignore
import { TestEmailWebhookCommand } from '../models';
/**
 * EmailWebhooksApi - axios parameter creator
 * @export
 */
export const EmailWebhooksApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Receive email webhooks events
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksInboundPost: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/emailwebhooks/inbound`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get email records. (from an week ago as default)
         * @param {Date} [createdFrom] 
         * @param {Date} [createdTo] 
         * @param {Date} [updatedFrom] 
         * @param {Date} [updatedTo] 
         * @param {string} [senderName] 
         * @param {string} [senderEmail] 
         * @param {string} [recipientName] 
         * @param {string} [recipientEmail] 
         * @param {Array<EmailStatus>} [statuses] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksRecordsGet: async (createdFrom?: Date, createdTo?: Date, updatedFrom?: Date, updatedTo?: Date, senderName?: string, senderEmail?: string, recipientName?: string, recipientEmail?: string, statuses?: Array<EmailStatus>, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/emailwebhooks/records`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (createdFrom !== undefined) {
                localVarQueryParameter['CreatedFrom'] = (createdFrom as any instanceof Date) ?
                    (createdFrom as any).toISOString() :
                    createdFrom;
            }

            if (createdTo !== undefined) {
                localVarQueryParameter['CreatedTo'] = (createdTo as any instanceof Date) ?
                    (createdTo as any).toISOString() :
                    createdTo;
            }

            if (updatedFrom !== undefined) {
                localVarQueryParameter['UpdatedFrom'] = (updatedFrom as any instanceof Date) ?
                    (updatedFrom as any).toISOString() :
                    updatedFrom;
            }

            if (updatedTo !== undefined) {
                localVarQueryParameter['UpdatedTo'] = (updatedTo as any instanceof Date) ?
                    (updatedTo as any).toISOString() :
                    updatedTo;
            }

            if (senderName !== undefined) {
                localVarQueryParameter['SenderName'] = senderName;
            }

            if (senderEmail !== undefined) {
                localVarQueryParameter['SenderEmail'] = senderEmail;
            }

            if (recipientName !== undefined) {
                localVarQueryParameter['RecipientName'] = recipientName;
            }

            if (recipientEmail !== undefined) {
                localVarQueryParameter['RecipientEmail'] = recipientEmail;
            }

            if (statuses) {
                localVarQueryParameter['Statuses'] = statuses;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get email record by id with events.
         * @param {string} recordId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksRecordsRecordIdGet: async (recordId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'recordId' is not null or undefined
            assertParamExists('apiV1EmailwebhooksRecordsRecordIdGet', 'recordId', recordId)
            const localVarPath = `/api/v1/emailwebhooks/records/{recordId}`
                .replace(`{${"recordId"}}`, encodeURIComponent(String(recordId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Sending test email that follows email webhook steps.
         * @param {TestEmailWebhookCommand} [testEmailWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksTestPost: async (testEmailWebhookCommand?: TestEmailWebhookCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/emailwebhooks/test`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(testEmailWebhookCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * EmailWebhooksApi - functional programming interface
 * @export
 */
export const EmailWebhooksApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = EmailWebhooksApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Receive email webhooks events
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailwebhooksInboundPost(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<object>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailwebhooksInboundPost(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get email records. (from an week ago as default)
         * @param {Date} [createdFrom] 
         * @param {Date} [createdTo] 
         * @param {Date} [updatedFrom] 
         * @param {Date} [updatedTo] 
         * @param {string} [senderName] 
         * @param {string} [senderEmail] 
         * @param {string} [recipientName] 
         * @param {string} [recipientEmail] 
         * @param {Array<EmailStatus>} [statuses] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailwebhooksRecordsGet(createdFrom?: Date, createdTo?: Date, updatedFrom?: Date, updatedTo?: Date, senderName?: string, senderEmail?: string, recipientName?: string, recipientEmail?: string, statuses?: Array<EmailStatus>, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EmailRecordsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailwebhooksRecordsGet(createdFrom, createdTo, updatedFrom, updatedTo, senderName, senderEmail, recipientName, recipientEmail, statuses, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get email record by id with events.
         * @param {string} recordId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailwebhooksRecordsRecordIdGet(recordId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<EmailRecordModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailwebhooksRecordsRecordIdGet(recordId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Sending test email that follows email webhook steps.
         * @param {TestEmailWebhookCommand} [testEmailWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1EmailwebhooksTestPost(testEmailWebhookCommand?: TestEmailWebhookCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TestEmailModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1EmailwebhooksTestPost(testEmailWebhookCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * EmailWebhooksApi - factory interface
 * @export
 */
export const EmailWebhooksApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = EmailWebhooksApiFp(configuration)
    return {
        /**
         * 
         * @summary Receive email webhooks events
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksInboundPost(options?: any): AxiosPromise<object> {
            return localVarFp.apiV1EmailwebhooksInboundPost(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get email records. (from an week ago as default)
         * @param {Date} [createdFrom] 
         * @param {Date} [createdTo] 
         * @param {Date} [updatedFrom] 
         * @param {Date} [updatedTo] 
         * @param {string} [senderName] 
         * @param {string} [senderEmail] 
         * @param {string} [recipientName] 
         * @param {string} [recipientEmail] 
         * @param {Array<EmailStatus>} [statuses] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksRecordsGet(createdFrom?: Date, createdTo?: Date, updatedFrom?: Date, updatedTo?: Date, senderName?: string, senderEmail?: string, recipientName?: string, recipientEmail?: string, statuses?: Array<EmailStatus>, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<EmailRecordsModel> {
            return localVarFp.apiV1EmailwebhooksRecordsGet(createdFrom, createdTo, updatedFrom, updatedTo, senderName, senderEmail, recipientName, recipientEmail, statuses, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get email record by id with events.
         * @param {string} recordId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksRecordsRecordIdGet(recordId: string, options?: any): AxiosPromise<EmailRecordModel> {
            return localVarFp.apiV1EmailwebhooksRecordsRecordIdGet(recordId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Sending test email that follows email webhook steps.
         * @param {TestEmailWebhookCommand} [testEmailWebhookCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1EmailwebhooksTestPost(testEmailWebhookCommand?: TestEmailWebhookCommand, options?: any): AxiosPromise<TestEmailModel> {
            return localVarFp.apiV1EmailwebhooksTestPost(testEmailWebhookCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1EmailwebhooksRecordsGet operation in EmailWebhooksApi.
 * @export
 * @interface EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest
 */
export interface EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest {
    /**
     * 
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly createdFrom?: Date

    /**
     * 
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly createdTo?: Date

    /**
     * 
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly updatedFrom?: Date

    /**
     * 
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly updatedTo?: Date

    /**
     * 
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly senderName?: string

    /**
     * 
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly senderEmail?: string

    /**
     * 
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly recipientName?: string

    /**
     * 
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly recipientEmail?: string

    /**
     * 
     * @type {Array<EmailStatus>}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly statuses?: Array<EmailStatus>

    /**
     * 
     * @type {number}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1EmailwebhooksRecordsRecordIdGet operation in EmailWebhooksApi.
 * @export
 * @interface EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest
 */
export interface EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGet
     */
    readonly recordId: string
}

/**
 * Request parameters for apiV1EmailwebhooksTestPost operation in EmailWebhooksApi.
 * @export
 * @interface EmailWebhooksApiApiV1EmailwebhooksTestPostRequest
 */
export interface EmailWebhooksApiApiV1EmailwebhooksTestPostRequest {
    /**
     * 
     * @type {TestEmailWebhookCommand}
     * @memberof EmailWebhooksApiApiV1EmailwebhooksTestPost
     */
    readonly testEmailWebhookCommand?: TestEmailWebhookCommand
}

/**
 * EmailWebhooksApi - object-oriented interface
 * @export
 * @class EmailWebhooksApi
 * @extends {BaseAPI}
 */
export class EmailWebhooksApi extends BaseAPI {
    /**
     * 
     * @summary Receive email webhooks events
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    public apiV1EmailwebhooksInboundPost(options?: AxiosRequestConfig) {
        return EmailWebhooksApiFp(this.configuration).apiV1EmailwebhooksInboundPost(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get email records. (from an week ago as default)
     * @param {EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    public apiV1EmailwebhooksRecordsGet(requestParameters: EmailWebhooksApiApiV1EmailwebhooksRecordsGetRequest = {}, options?: AxiosRequestConfig) {
        return EmailWebhooksApiFp(this.configuration).apiV1EmailwebhooksRecordsGet(requestParameters.createdFrom, requestParameters.createdTo, requestParameters.updatedFrom, requestParameters.updatedTo, requestParameters.senderName, requestParameters.senderEmail, requestParameters.recipientName, requestParameters.recipientEmail, requestParameters.statuses, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get email record by id with events.
     * @param {EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    public apiV1EmailwebhooksRecordsRecordIdGet(requestParameters: EmailWebhooksApiApiV1EmailwebhooksRecordsRecordIdGetRequest, options?: AxiosRequestConfig) {
        return EmailWebhooksApiFp(this.configuration).apiV1EmailwebhooksRecordsRecordIdGet(requestParameters.recordId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Sending test email that follows email webhook steps.
     * @param {EmailWebhooksApiApiV1EmailwebhooksTestPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof EmailWebhooksApi
     */
    public apiV1EmailwebhooksTestPost(requestParameters: EmailWebhooksApiApiV1EmailwebhooksTestPostRequest = {}, options?: AxiosRequestConfig) {
        return EmailWebhooksApiFp(this.configuration).apiV1EmailwebhooksTestPost(requestParameters.testEmailWebhookCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
