/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreateFaqCommand } from '../models';
// @ts-ignore
import { CreateFaqTagCommand } from '../models';
// @ts-ignore
import { CreateMediaCommand } from '../models';
// @ts-ignore
import { FaqModel } from '../models';
// @ts-ignore
import { FaqTagModel } from '../models';
// @ts-ignore
import { FaqTagsModel } from '../models';
// @ts-ignore
import { FaqsModel } from '../models';
// @ts-ignore
import { MediaModel } from '../models';
// @ts-ignore
import { MediaType } from '../models';
// @ts-ignore
import { MediasModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateFaqCommand } from '../models';
// @ts-ignore
import { UpdateMediaCommand } from '../models';
/**
 * FaqsApi - axios parameter creator
 * @export
 */
export const FaqsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete faq.
         * @param {string} faqId 
         * @param {boolean} [forceDelete] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdDelete: async (faqId: string, forceDelete?: boolean, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdDelete', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (forceDelete !== undefined) {
                localVarQueryParameter['forceDelete'] = forceDelete;
            }

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get faq.
         * @param {string} faqId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdGet: async (faqId: string, languageCode?: string, returnDefaultValue?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdGet', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['returnDefaultValue'] = returnDefaultValue;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all FaqMedias.
         * @param {string} faqId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasGet: async (faqId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasGet', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}/medias`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (mediaType !== undefined) {
                localVarQueryParameter['MediaType'] = mediaType;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete FaqMedia
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasMediaIdDelete: async (faqId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasMediaIdDelete', 'faqId', faqId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasMediaIdDelete', 'mediaId', mediaId)
            const localVarPath = `/api/v1/faqs/{faqId}/medias/{mediaId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get FaqMedia.
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasMediaIdGet: async (faqId: string, mediaId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasMediaIdGet', 'faqId', faqId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasMediaIdGet', 'mediaId', mediaId)
            const localVarPath = `/api/v1/faqs/{faqId}/medias/{mediaId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update FaqMedia.
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasMediaIdPut: async (faqId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasMediaIdPut', 'faqId', faqId)
            // verify required parameter 'mediaId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasMediaIdPut', 'mediaId', mediaId)
            const localVarPath = `/api/v1/faqs/{faqId}/medias/{mediaId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)))
                .replace(`{${"mediaId"}}`, encodeURIComponent(String(mediaId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create FaqMedia.
         * @param {string} faqId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasPost: async (faqId: string, createMediaCommand?: CreateMediaCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdMediasPost', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}/medias`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createMediaCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update faq.
         * @param {string} faqId 
         * @param {UpdateFaqCommand} [updateFaqCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdPut: async (faqId: string, updateFaqCommand?: UpdateFaqCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdPut', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateFaqCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Revalidate faq
         * @param {string} faqId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdRevalidatePost: async (faqId: string, includeCurrent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdRevalidatePost', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}/revalidate`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (includeCurrent !== undefined) {
                localVarQueryParameter['includeCurrent'] = includeCurrent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary GetAll FaqTags.
         * @param {string} faqId 
         * @param {string} [tagId] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsGet: async (faqId: string, tagId?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdTagsGet', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}/tags`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (tagId !== undefined) {
                localVarQueryParameter['TagId'] = tagId;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create FaqTag.
         * @param {string} faqId 
         * @param {CreateFaqTagCommand} [createFaqTagCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsPost: async (faqId: string, createFaqTagCommand?: CreateFaqTagCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdTagsPost', 'faqId', faqId)
            const localVarPath = `/api/v1/faqs/{faqId}/tags`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createFaqTagCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete FaqTag.
         * @param {string} faqId 
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsTagIdDelete: async (faqId: string, tagId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdTagsTagIdDelete', 'faqId', faqId)
            // verify required parameter 'tagId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdTagsTagIdDelete', 'tagId', tagId)
            const localVarPath = `/api/v1/faqs/{faqId}/tags/{tagId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)))
                .replace(`{${"tagId"}}`, encodeURIComponent(String(tagId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get FaqTag.
         * @param {string} faqId 
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsTagIdGet: async (faqId: string, tagId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'faqId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdTagsTagIdGet', 'faqId', faqId)
            // verify required parameter 'tagId' is not null or undefined
            assertParamExists('apiV1FaqsFaqIdTagsTagIdGet', 'tagId', tagId)
            const localVarPath = `/api/v1/faqs/{faqId}/tags/{tagId}`
                .replace(`{${"faqId"}}`, encodeURIComponent(String(faqId)))
                .replace(`{${"tagId"}}`, encodeURIComponent(String(tagId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get all Faqs.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [slug] 
         * @param {string} [categoryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsGet: async (id?: string, name?: string, slug?: string, categoryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/faqs`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (id !== undefined) {
                localVarQueryParameter['Id'] = id;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (slug !== undefined) {
                localVarQueryParameter['Slug'] = slug;
            }

            if (categoryId !== undefined) {
                localVarQueryParameter['CategoryId'] = categoryId;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (hospitalName !== undefined) {
                localVarQueryParameter['HospitalName'] = hospitalName;
            }

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (returnDefaultValue !== undefined) {
                localVarQueryParameter['ReturnDefaultValue'] = returnDefaultValue;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a faq.
         * @param {CreateFaqCommand} [createFaqCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsPost: async (createFaqCommand?: CreateFaqCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/faqs`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createFaqCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get faq by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsSlugGet: async (slug: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'slug' is not null or undefined
            assertParamExists('apiV1FaqsSlugGet', 'slug', slug)
            const localVarPath = `/api/v1/faqs/{slug}`
                .replace(`{${"slug"}}`, encodeURIComponent(String(slug)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FaqsApi - functional programming interface
 * @export
 */
export const FaqsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = FaqsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete faq.
         * @param {string} faqId 
         * @param {boolean} [forceDelete] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdDelete(faqId: string, forceDelete?: boolean, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdDelete(faqId, forceDelete, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get faq.
         * @param {string} faqId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdGet(faqId: string, languageCode?: string, returnDefaultValue?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdGet(faqId, languageCode, returnDefaultValue, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all FaqMedias.
         * @param {string} faqId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdMediasGet(faqId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediasModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdMediasGet(faqId, id, mediaType, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete FaqMedia
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdMediasMediaIdDelete(faqId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdMediasMediaIdDelete(faqId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get FaqMedia.
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdMediasMediaIdGet(faqId: string, mediaId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdMediasMediaIdGet(faqId, mediaId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update FaqMedia.
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdMediasMediaIdPut(faqId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdMediasMediaIdPut(faqId, mediaId, updateMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create FaqMedia.
         * @param {string} faqId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdMediasPost(faqId: string, createMediaCommand?: CreateMediaCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<MediaModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdMediasPost(faqId, createMediaCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update faq.
         * @param {string} faqId 
         * @param {UpdateFaqCommand} [updateFaqCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdPut(faqId: string, updateFaqCommand?: UpdateFaqCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdPut(faqId, updateFaqCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Revalidate faq
         * @param {string} faqId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdRevalidatePost(faqId: string, includeCurrent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdRevalidatePost(faqId, includeCurrent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary GetAll FaqTags.
         * @param {string} faqId 
         * @param {string} [tagId] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdTagsGet(faqId: string, tagId?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqTagsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdTagsGet(faqId, tagId, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create FaqTag.
         * @param {string} faqId 
         * @param {CreateFaqTagCommand} [createFaqTagCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdTagsPost(faqId: string, createFaqTagCommand?: CreateFaqTagCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqTagModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdTagsPost(faqId, createFaqTagCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete FaqTag.
         * @param {string} faqId 
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdTagsTagIdDelete(faqId: string, tagId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdTagsTagIdDelete(faqId, tagId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get FaqTag.
         * @param {string} faqId 
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsFaqIdTagsTagIdGet(faqId: string, tagId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqTagModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsFaqIdTagsTagIdGet(faqId, tagId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get all Faqs.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [slug] 
         * @param {string} [categoryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsGet(id?: string, name?: string, slug?: string, categoryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsGet(id, name, slug, categoryId, hospitalId, hospitalName, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a faq.
         * @param {CreateFaqCommand} [createFaqCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsPost(createFaqCommand?: CreateFaqCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsPost(createFaqCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get faq by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FaqsSlugGet(slug: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FaqModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FaqsSlugGet(slug, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * FaqsApi - factory interface
 * @export
 */
export const FaqsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = FaqsApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete faq.
         * @param {string} faqId 
         * @param {boolean} [forceDelete] 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdDelete(faqId: string, forceDelete?: boolean, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FaqsFaqIdDelete(faqId, forceDelete, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get faq.
         * @param {string} faqId 
         * @param {string} [languageCode] 
         * @param {boolean} [returnDefaultValue] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdGet(faqId: string, languageCode?: string, returnDefaultValue?: boolean, options?: any): AxiosPromise<FaqModel> {
            return localVarFp.apiV1FaqsFaqIdGet(faqId, languageCode, returnDefaultValue, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all FaqMedias.
         * @param {string} faqId 
         * @param {string} [id] 
         * @param {MediaType} [mediaType] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasGet(faqId: string, id?: string, mediaType?: MediaType, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<MediasModel> {
            return localVarFp.apiV1FaqsFaqIdMediasGet(faqId, id, mediaType, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete FaqMedia
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasMediaIdDelete(faqId: string, mediaId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FaqsFaqIdMediasMediaIdDelete(faqId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get FaqMedia.
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasMediaIdGet(faqId: string, mediaId: string, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1FaqsFaqIdMediasMediaIdGet(faqId, mediaId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update FaqMedia.
         * @param {string} faqId 
         * @param {string} mediaId 
         * @param {UpdateMediaCommand} [updateMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasMediaIdPut(faqId: string, mediaId: string, updateMediaCommand?: UpdateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1FaqsFaqIdMediasMediaIdPut(faqId, mediaId, updateMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create FaqMedia.
         * @param {string} faqId 
         * @param {CreateMediaCommand} [createMediaCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdMediasPost(faqId: string, createMediaCommand?: CreateMediaCommand, options?: any): AxiosPromise<MediaModel> {
            return localVarFp.apiV1FaqsFaqIdMediasPost(faqId, createMediaCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update faq.
         * @param {string} faqId 
         * @param {UpdateFaqCommand} [updateFaqCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdPut(faqId: string, updateFaqCommand?: UpdateFaqCommand, options?: any): AxiosPromise<FaqModel> {
            return localVarFp.apiV1FaqsFaqIdPut(faqId, updateFaqCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Revalidate faq
         * @param {string} faqId 
         * @param {boolean} [includeCurrent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdRevalidatePost(faqId: string, includeCurrent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FaqsFaqIdRevalidatePost(faqId, includeCurrent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary GetAll FaqTags.
         * @param {string} faqId 
         * @param {string} [tagId] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsGet(faqId: string, tagId?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FaqTagsModel> {
            return localVarFp.apiV1FaqsFaqIdTagsGet(faqId, tagId, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create FaqTag.
         * @param {string} faqId 
         * @param {CreateFaqTagCommand} [createFaqTagCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsPost(faqId: string, createFaqTagCommand?: CreateFaqTagCommand, options?: any): AxiosPromise<FaqTagModel> {
            return localVarFp.apiV1FaqsFaqIdTagsPost(faqId, createFaqTagCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete FaqTag.
         * @param {string} faqId 
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsTagIdDelete(faqId: string, tagId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FaqsFaqIdTagsTagIdDelete(faqId, tagId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get FaqTag.
         * @param {string} faqId 
         * @param {string} tagId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsFaqIdTagsTagIdGet(faqId: string, tagId: string, options?: any): AxiosPromise<FaqTagModel> {
            return localVarFp.apiV1FaqsFaqIdTagsTagIdGet(faqId, tagId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get all Faqs.
         * @param {string} [id] 
         * @param {string} [name] 
         * @param {string} [slug] 
         * @param {string} [categoryId] 
         * @param {string} [hospitalId] 
         * @param {string} [hospitalName] 
         * @param {string} [languageCode] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [returnDefaultValue] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsGet(id?: string, name?: string, slug?: string, categoryId?: string, hospitalId?: string, hospitalName?: string, languageCode?: string, showHidden?: boolean, returnDefaultValue?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FaqsModel> {
            return localVarFp.apiV1FaqsGet(id, name, slug, categoryId, hospitalId, hospitalName, languageCode, showHidden, returnDefaultValue, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a faq.
         * @param {CreateFaqCommand} [createFaqCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsPost(createFaqCommand?: CreateFaqCommand, options?: any): AxiosPromise<FaqModel> {
            return localVarFp.apiV1FaqsPost(createFaqCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get faq by slug.
         * @param {string} slug 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FaqsSlugGet(slug: string, languageCode?: string, options?: any): AxiosPromise<FaqModel> {
            return localVarFp.apiV1FaqsSlugGet(slug, languageCode, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1FaqsFaqIdDelete operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdDeleteRequest
 */
export interface FaqsApiApiV1FaqsFaqIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdDelete
     */
    readonly faqId: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdDelete
     */
    readonly forceDelete?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1FaqsFaqIdGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdGet
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdGet
     */
    readonly returnDefaultValue?: boolean
}

/**
 * Request parameters for apiV1FaqsFaqIdMediasGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly id?: string

    /**
     * 
     * @type {MediaType}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly mediaType?: MediaType

    /**
     * 
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1FaqsFaqIdMediasMediaIdDelete operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdDelete
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdDelete
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1FaqsFaqIdMediasMediaIdGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdGet
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdGet
     */
    readonly mediaId: string
}

/**
 * Request parameters for apiV1FaqsFaqIdMediasMediaIdPut operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdPut
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdPut
     */
    readonly mediaId: string

    /**
     * 
     * @type {UpdateMediaCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasMediaIdPut
     */
    readonly updateMediaCommand?: UpdateMediaCommand
}

/**
 * Request parameters for apiV1FaqsFaqIdMediasPost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdMediasPostRequest
 */
export interface FaqsApiApiV1FaqsFaqIdMediasPostRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasPost
     */
    readonly faqId: string

    /**
     * 
     * @type {CreateMediaCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdMediasPost
     */
    readonly createMediaCommand?: CreateMediaCommand
}

/**
 * Request parameters for apiV1FaqsFaqIdPut operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdPutRequest
 */
export interface FaqsApiApiV1FaqsFaqIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdPut
     */
    readonly faqId: string

    /**
     * 
     * @type {UpdateFaqCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdPut
     */
    readonly updateFaqCommand?: UpdateFaqCommand
}

/**
 * Request parameters for apiV1FaqsFaqIdRevalidatePost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdRevalidatePostRequest
 */
export interface FaqsApiApiV1FaqsFaqIdRevalidatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdRevalidatePost
     */
    readonly faqId: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsFaqIdRevalidatePost
     */
    readonly includeCurrent?: boolean
}

/**
 * Request parameters for apiV1FaqsFaqIdTagsGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly tagId?: string

    /**
     * 
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1FaqsFaqIdTagsPost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsPostRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsPostRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsPost
     */
    readonly faqId: string

    /**
     * 
     * @type {CreateFaqTagCommand}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsPost
     */
    readonly createFaqTagCommand?: CreateFaqTagCommand
}

/**
 * Request parameters for apiV1FaqsFaqIdTagsTagIdDelete operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdDelete
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdDelete
     */
    readonly tagId: string
}

/**
 * Request parameters for apiV1FaqsFaqIdTagsTagIdGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest
 */
export interface FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdGet
     */
    readonly faqId: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsFaqIdTagsTagIdGet
     */
    readonly tagId: string
}

/**
 * Request parameters for apiV1FaqsGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsGetRequest
 */
export interface FaqsApiApiV1FaqsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly id?: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly slug?: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly categoryId?: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly hospitalName?: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly returnDefaultValue?: boolean

    /**
     * 
     * @type {number}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FaqsApiApiV1FaqsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1FaqsPost operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsPostRequest
 */
export interface FaqsApiApiV1FaqsPostRequest {
    /**
     * 
     * @type {CreateFaqCommand}
     * @memberof FaqsApiApiV1FaqsPost
     */
    readonly createFaqCommand?: CreateFaqCommand
}

/**
 * Request parameters for apiV1FaqsSlugGet operation in FaqsApi.
 * @export
 * @interface FaqsApiApiV1FaqsSlugGetRequest
 */
export interface FaqsApiApiV1FaqsSlugGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsSlugGet
     */
    readonly slug: string

    /**
     * 
     * @type {string}
     * @memberof FaqsApiApiV1FaqsSlugGet
     */
    readonly languageCode?: string
}

/**
 * FaqsApi - object-oriented interface
 * @export
 * @class FaqsApi
 * @extends {BaseAPI}
 */
export class FaqsApi extends BaseAPI {
    /**
     * 
     * @summary Delete faq.
     * @param {FaqsApiApiV1FaqsFaqIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdDelete(requestParameters: FaqsApiApiV1FaqsFaqIdDeleteRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdDelete(requestParameters.faqId, requestParameters.forceDelete, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get faq.
     * @param {FaqsApiApiV1FaqsFaqIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdGet(requestParameters: FaqsApiApiV1FaqsFaqIdGetRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdGet(requestParameters.faqId, requestParameters.languageCode, requestParameters.returnDefaultValue, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all FaqMedias.
     * @param {FaqsApiApiV1FaqsFaqIdMediasGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdMediasGet(requestParameters: FaqsApiApiV1FaqsFaqIdMediasGetRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdMediasGet(requestParameters.faqId, requestParameters.id, requestParameters.mediaType, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete FaqMedia
     * @param {FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdMediasMediaIdDelete(requestParameters: FaqsApiApiV1FaqsFaqIdMediasMediaIdDeleteRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdMediasMediaIdDelete(requestParameters.faqId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get FaqMedia.
     * @param {FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdMediasMediaIdGet(requestParameters: FaqsApiApiV1FaqsFaqIdMediasMediaIdGetRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdMediasMediaIdGet(requestParameters.faqId, requestParameters.mediaId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update FaqMedia.
     * @param {FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdMediasMediaIdPut(requestParameters: FaqsApiApiV1FaqsFaqIdMediasMediaIdPutRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdMediasMediaIdPut(requestParameters.faqId, requestParameters.mediaId, requestParameters.updateMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create FaqMedia.
     * @param {FaqsApiApiV1FaqsFaqIdMediasPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdMediasPost(requestParameters: FaqsApiApiV1FaqsFaqIdMediasPostRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdMediasPost(requestParameters.faqId, requestParameters.createMediaCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update faq.
     * @param {FaqsApiApiV1FaqsFaqIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdPut(requestParameters: FaqsApiApiV1FaqsFaqIdPutRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdPut(requestParameters.faqId, requestParameters.updateFaqCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Revalidate faq
     * @param {FaqsApiApiV1FaqsFaqIdRevalidatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdRevalidatePost(requestParameters: FaqsApiApiV1FaqsFaqIdRevalidatePostRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdRevalidatePost(requestParameters.faqId, requestParameters.includeCurrent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary GetAll FaqTags.
     * @param {FaqsApiApiV1FaqsFaqIdTagsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdTagsGet(requestParameters: FaqsApiApiV1FaqsFaqIdTagsGetRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdTagsGet(requestParameters.faqId, requestParameters.tagId, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create FaqTag.
     * @param {FaqsApiApiV1FaqsFaqIdTagsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdTagsPost(requestParameters: FaqsApiApiV1FaqsFaqIdTagsPostRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdTagsPost(requestParameters.faqId, requestParameters.createFaqTagCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete FaqTag.
     * @param {FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdTagsTagIdDelete(requestParameters: FaqsApiApiV1FaqsFaqIdTagsTagIdDeleteRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdTagsTagIdDelete(requestParameters.faqId, requestParameters.tagId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get FaqTag.
     * @param {FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsFaqIdTagsTagIdGet(requestParameters: FaqsApiApiV1FaqsFaqIdTagsTagIdGetRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsFaqIdTagsTagIdGet(requestParameters.faqId, requestParameters.tagId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get all Faqs.
     * @param {FaqsApiApiV1FaqsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsGet(requestParameters: FaqsApiApiV1FaqsGetRequest = {}, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsGet(requestParameters.id, requestParameters.name, requestParameters.slug, requestParameters.categoryId, requestParameters.hospitalId, requestParameters.hospitalName, requestParameters.languageCode, requestParameters.showHidden, requestParameters.returnDefaultValue, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a faq.
     * @param {FaqsApiApiV1FaqsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsPost(requestParameters: FaqsApiApiV1FaqsPostRequest = {}, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsPost(requestParameters.createFaqCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get faq by slug.
     * @param {FaqsApiApiV1FaqsSlugGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FaqsApi
     */
    public apiV1FaqsSlugGet(requestParameters: FaqsApiApiV1FaqsSlugGetRequest, options?: AxiosRequestConfig) {
        return FaqsApiFp(this.configuration).apiV1FaqsSlugGet(requestParameters.slug, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }
}
