/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { FormTemplateAffiliationsModel } from '../models';
// @ts-ignore
import { FormTemplateModel } from '../models';
// @ts-ignore
import { FormTemplatePlatform } from '../models';
// @ts-ignore
import { FormTemplateStatus } from '../models';
// @ts-ignore
import { FormTemplateType } from '../models';
// @ts-ignore
import { FormTemplatesModel } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { SaveFormTemplateCommand } from '../models';
// @ts-ignore
import { SetHospitalIntoFormTemplateCommand } from '../models';
// @ts-ignore
import { TranslateFormTemplateCommand } from '../models';
// @ts-ignore
import { TranslationBatchResultModel } from '../models';
/**
 * FormTemplatesApi - axios parameter creator
 * @export
 */
export const FormTemplatesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Delete formTemplate
         * @param {string} formTemplateId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdDelete: async (formTemplateId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdDelete', 'formTemplateId', formTemplateId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get formTemplateAffilitions
         * @param {string} formTemplateId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet: async (formTemplateId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet', 'formTemplateId', formTemplateId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}/formtemplateaffiliations`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get formTemplate
         * @param {string} formTemplateId 
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdGet: async (formTemplateId: string, languageCode?: string, hospitalId?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdGet', 'formTemplateId', formTemplateId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['hospitalId'] = hospitalId;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Remove hospital from formTemplateAffiliations
         * @param {string} formTemplateId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete: async (formTemplateId: string, hospitalId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete', 'formTemplateId', formTemplateId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}/hospitals/{hospitalId}`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Add hospital into formTemplateAffiliations.
         * @param {string} formTemplateId 
         * @param {string} hospitalId 
         * @param {SetHospitalIntoFormTemplateCommand} [setHospitalIntoFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost: async (formTemplateId: string, hospitalId: string, setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost', 'formTemplateId', formTemplateId)
            // verify required parameter 'hospitalId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost', 'hospitalId', hospitalId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}/hospitals/{hospitalId}`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)))
                .replace(`{${"hospitalId"}}`, encodeURIComponent(String(hospitalId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(setHospitalIntoFormTemplateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update formTemplate
         * @param {string} formTemplateId 
         * @param {SaveFormTemplateCommand} [saveFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdPut: async (formTemplateId: string, saveFormTemplateCommand?: SaveFormTemplateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdPut', 'formTemplateId', formTemplateId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(saveFormTemplateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate formTemplate
         * @param {string} formTemplateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdReactivatePut: async (formTemplateId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdReactivatePut', 'formTemplateId', formTemplateId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}/reactivate`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Translate formTemplate
         * @param {string} formTemplateId 
         * @param {TranslateFormTemplateCommand} [translateFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdTranslatePost: async (formTemplateId: string, translateFormTemplateCommand?: TranslateFormTemplateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'formTemplateId' is not null or undefined
            assertParamExists('apiV1FormtemplatesFormTemplateIdTranslatePost', 'formTemplateId', formTemplateId)
            const localVarPath = `/api/v1/formtemplates/{formTemplateId}/translate`
                .replace(`{${"formTemplateId"}}`, encodeURIComponent(String(formTemplateId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(translateFormTemplateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get formTemplates
         * @param {string} [languageCode] 
         * @param {string} [name] 
         * @param {string} [hospitalId] 
         * @param {FormTemplatePlatform} [platform] 
         * @param {FormTemplateType} [formTemplateType] 
         * @param {FormTemplateStatus} [status] 
         * @param {boolean} [isShared] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesGet: async (languageCode?: string, name?: string, hospitalId?: string, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormTemplateStatus, isShared?: boolean, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/formtemplates`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (name !== undefined) {
                localVarQueryParameter['Name'] = name;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (platform !== undefined) {
                localVarQueryParameter['Platform'] = platform;
            }

            if (formTemplateType !== undefined) {
                localVarQueryParameter['FormTemplateType'] = formTemplateType;
            }

            if (status !== undefined) {
                localVarQueryParameter['Status'] = status;
            }

            if (isShared !== undefined) {
                localVarQueryParameter['IsShared'] = isShared;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create formTemplate
         * @param {SaveFormTemplateCommand} [saveFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesPost: async (saveFormTemplateCommand?: SaveFormTemplateCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/formtemplates`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(saveFormTemplateCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * FormTemplatesApi - functional programming interface
 * @export
 */
export const FormTemplatesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = FormTemplatesApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Delete formTemplate
         * @param {string} formTemplateId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdDelete(formTemplateId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdDelete(formTemplateId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get formTemplateAffilitions
         * @param {string} formTemplateId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(formTemplateId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateAffiliationsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(formTemplateId, languageCode, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get formTemplate
         * @param {string} formTemplateId 
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdGet(formTemplateId: string, languageCode?: string, hospitalId?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdGet(formTemplateId, languageCode, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Remove hospital from formTemplateAffiliations
         * @param {string} formTemplateId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(formTemplateId: string, hospitalId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(formTemplateId, hospitalId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Add hospital into formTemplateAffiliations.
         * @param {string} formTemplateId 
         * @param {string} hospitalId 
         * @param {SetHospitalIntoFormTemplateCommand} [setHospitalIntoFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(formTemplateId: string, hospitalId: string, setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(formTemplateId, hospitalId, setHospitalIntoFormTemplateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update formTemplate
         * @param {string} formTemplateId 
         * @param {SaveFormTemplateCommand} [saveFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdPut(formTemplateId: string, saveFormTemplateCommand?: SaveFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdPut(formTemplateId, saveFormTemplateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate formTemplate
         * @param {string} formTemplateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdReactivatePut(formTemplateId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdReactivatePut(formTemplateId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Translate formTemplate
         * @param {string} formTemplateId 
         * @param {TranslateFormTemplateCommand} [translateFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesFormTemplateIdTranslatePost(formTemplateId: string, translateFormTemplateCommand?: TranslateFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<TranslationBatchResultModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesFormTemplateIdTranslatePost(formTemplateId, translateFormTemplateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get formTemplates
         * @param {string} [languageCode] 
         * @param {string} [name] 
         * @param {string} [hospitalId] 
         * @param {FormTemplatePlatform} [platform] 
         * @param {FormTemplateType} [formTemplateType] 
         * @param {FormTemplateStatus} [status] 
         * @param {boolean} [isShared] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesGet(languageCode?: string, name?: string, hospitalId?: string, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormTemplateStatus, isShared?: boolean, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplatesModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesGet(languageCode, name, hospitalId, platform, formTemplateType, status, isShared, showHidden, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create formTemplate
         * @param {SaveFormTemplateCommand} [saveFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1FormtemplatesPost(saveFormTemplateCommand?: SaveFormTemplateCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<FormTemplateModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1FormtemplatesPost(saveFormTemplateCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * FormTemplatesApi - factory interface
 * @export
 */
export const FormTemplatesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = FormTemplatesApiFp(configuration)
    return {
        /**
         * 
         * @summary Delete formTemplate
         * @param {string} formTemplateId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdDelete(formTemplateId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdDelete(formTemplateId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get formTemplateAffilitions
         * @param {string} formTemplateId 
         * @param {string} [languageCode] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(formTemplateId: string, languageCode?: string, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FormTemplateAffiliationsModel> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(formTemplateId, languageCode, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get formTemplate
         * @param {string} formTemplateId 
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdGet(formTemplateId: string, languageCode?: string, hospitalId?: string, options?: any): AxiosPromise<FormTemplateModel> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdGet(formTemplateId, languageCode, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Remove hospital from formTemplateAffiliations
         * @param {string} formTemplateId 
         * @param {string} hospitalId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(formTemplateId: string, hospitalId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(formTemplateId, hospitalId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Add hospital into formTemplateAffiliations.
         * @param {string} formTemplateId 
         * @param {string} hospitalId 
         * @param {SetHospitalIntoFormTemplateCommand} [setHospitalIntoFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(formTemplateId: string, hospitalId: string, setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(formTemplateId, hospitalId, setHospitalIntoFormTemplateCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update formTemplate
         * @param {string} formTemplateId 
         * @param {SaveFormTemplateCommand} [saveFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdPut(formTemplateId: string, saveFormTemplateCommand?: SaveFormTemplateCommand, options?: any): AxiosPromise<FormTemplateModel> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdPut(formTemplateId, saveFormTemplateCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate formTemplate
         * @param {string} formTemplateId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdReactivatePut(formTemplateId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdReactivatePut(formTemplateId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Translate formTemplate
         * @param {string} formTemplateId 
         * @param {TranslateFormTemplateCommand} [translateFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesFormTemplateIdTranslatePost(formTemplateId: string, translateFormTemplateCommand?: TranslateFormTemplateCommand, options?: any): AxiosPromise<TranslationBatchResultModel> {
            return localVarFp.apiV1FormtemplatesFormTemplateIdTranslatePost(formTemplateId, translateFormTemplateCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get formTemplates
         * @param {string} [languageCode] 
         * @param {string} [name] 
         * @param {string} [hospitalId] 
         * @param {FormTemplatePlatform} [platform] 
         * @param {FormTemplateType} [formTemplateType] 
         * @param {FormTemplateStatus} [status] 
         * @param {boolean} [isShared] 
         * @param {boolean} [showHidden] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesGet(languageCode?: string, name?: string, hospitalId?: string, platform?: FormTemplatePlatform, formTemplateType?: FormTemplateType, status?: FormTemplateStatus, isShared?: boolean, showHidden?: boolean, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<FormTemplatesModel> {
            return localVarFp.apiV1FormtemplatesGet(languageCode, name, hospitalId, platform, formTemplateType, status, isShared, showHidden, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create formTemplate
         * @param {SaveFormTemplateCommand} [saveFormTemplateCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1FormtemplatesPost(saveFormTemplateCommand?: SaveFormTemplateCommand, options?: any): AxiosPromise<FormTemplateModel> {
            return localVarFp.apiV1FormtemplatesPost(saveFormTemplateCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdDelete operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdDelete
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {boolean}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdGet operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdGet
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdGet
     */
    readonly hospitalId?: string
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete
     */
    readonly hospitalId: string
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost
     */
    readonly hospitalId: string

    /**
     * 
     * @type {SetHospitalIntoFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost
     */
    readonly setHospitalIntoFormTemplateCommand?: SetHospitalIntoFormTemplateCommand
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdPut operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdPut
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {SaveFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdPut
     */
    readonly saveFormTemplateCommand?: SaveFormTemplateCommand
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdReactivatePut operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePut
     */
    readonly formTemplateId: string
}

/**
 * Request parameters for apiV1FormtemplatesFormTemplateIdTranslatePost operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePost
     */
    readonly formTemplateId: string

    /**
     * 
     * @type {TranslateFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePost
     */
    readonly translateFormTemplateCommand?: TranslateFormTemplateCommand
}

/**
 * Request parameters for apiV1FormtemplatesGet operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesGetRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesGetRequest {
    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly name?: string

    /**
     * 
     * @type {string}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {FormTemplatePlatform}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly platform?: FormTemplatePlatform

    /**
     * 
     * @type {FormTemplateType}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly formTemplateType?: FormTemplateType

    /**
     * 
     * @type {FormTemplateStatus}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly status?: FormTemplateStatus

    /**
     * 
     * @type {boolean}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly isShared?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof FormTemplatesApiApiV1FormtemplatesGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1FormtemplatesPost operation in FormTemplatesApi.
 * @export
 * @interface FormTemplatesApiApiV1FormtemplatesPostRequest
 */
export interface FormTemplatesApiApiV1FormtemplatesPostRequest {
    /**
     * 
     * @type {SaveFormTemplateCommand}
     * @memberof FormTemplatesApiApiV1FormtemplatesPost
     */
    readonly saveFormTemplateCommand?: SaveFormTemplateCommand
}

/**
 * FormTemplatesApi - object-oriented interface
 * @export
 * @class FormTemplatesApi
 * @extends {BaseAPI}
 */
export class FormTemplatesApi extends BaseAPI {
    /**
     * 
     * @summary Delete formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdDelete(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdDeleteRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdDelete(requestParameters.formTemplateId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get formTemplateAffilitions
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGetRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdFormtemplateaffiliationsGet(requestParameters.formTemplateId, requestParameters.languageCode, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdGet(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdGetRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdGet(requestParameters.formTemplateId, requestParameters.languageCode, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Remove hospital from formTemplateAffiliations
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDeleteRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdDelete(requestParameters.formTemplateId, requestParameters.hospitalId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Add hospital into formTemplateAffiliations.
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPostRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdHospitalsHospitalIdPost(requestParameters.formTemplateId, requestParameters.hospitalId, requestParameters.setHospitalIntoFormTemplateCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdPut(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdPutRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdPut(requestParameters.formTemplateId, requestParameters.saveFormTemplateCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdReactivatePut(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdReactivatePut(requestParameters.formTemplateId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Translate formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesFormTemplateIdTranslatePost(requestParameters: FormTemplatesApiApiV1FormtemplatesFormTemplateIdTranslatePostRequest, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesFormTemplateIdTranslatePost(requestParameters.formTemplateId, requestParameters.translateFormTemplateCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get formTemplates
     * @param {FormTemplatesApiApiV1FormtemplatesGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesGet(requestParameters: FormTemplatesApiApiV1FormtemplatesGetRequest = {}, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesGet(requestParameters.languageCode, requestParameters.name, requestParameters.hospitalId, requestParameters.platform, requestParameters.formTemplateType, requestParameters.status, requestParameters.isShared, requestParameters.showHidden, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create formTemplate
     * @param {FormTemplatesApiApiV1FormtemplatesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof FormTemplatesApi
     */
    public apiV1FormtemplatesPost(requestParameters: FormTemplatesApiApiV1FormtemplatesPostRequest = {}, options?: AxiosRequestConfig) {
        return FormTemplatesApiFp(this.configuration).apiV1FormtemplatesPost(requestParameters.saveFormTemplateCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
