/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { ChangeEmailCommand } from '../models';
// @ts-ignore
import { ConfirmEmailCommand } from '../models';
// @ts-ignore
import { CreateProfileCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { UpdateProfileCommand } from '../models';
// @ts-ignore
import { UserModel } from '../models';
/**
 * ProfilesApi - axios parameter creator
 * @export
 */
export const ProfilesApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * Sample request:        POST /api/v1/profiles/changeEmail      {          \"email\": \"user@example.com\"      }
         * @summary Change user\'s email on both Identity and Api.
         * @param {ChangeEmailCommand} [changeEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesChangeemailPost: async (changeEmailCommand?: ChangeEmailCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/profiles/changeemail`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(changeEmailCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Configm email.
         * @param {ConfirmEmailCommand} [confirmEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesConfirmemailPost: async (confirmEmailCommand?: ConfirmEmailCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/profiles/confirmemail`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(confirmEmailCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get Profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesGet: async (options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create a Profile.
         * @param {CreateProfileCommand} [createProfileCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesPost: async (createProfileCommand?: CreateProfileCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createProfileCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete Profile.
         * @param {string} profileId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesProfileIdDelete: async (profileId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'profileId' is not null or undefined
            assertParamExists('apiV1ProfilesProfileIdDelete', 'profileId', profileId)
            const localVarPath = `/api/v1/profiles/{profileId}`
                .replace(`{${"profileId"}}`, encodeURIComponent(String(profileId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update Profile.
         * @param {UpdateProfileCommand} [updateProfileCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesPut: async (updateProfileCommand?: UpdateProfileCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/profiles`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updateProfileCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * ProfilesApi - functional programming interface
 * @export
 */
export const ProfilesApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = ProfilesApiAxiosParamCreator(configuration)
    return {
        /**
         * Sample request:        POST /api/v1/profiles/changeEmail      {          \"email\": \"user@example.com\"      }
         * @summary Change user\'s email on both Identity and Api.
         * @param {ChangeEmailCommand} [changeEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ProfilesChangeemailPost(changeEmailCommand?: ChangeEmailCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ProfilesChangeemailPost(changeEmailCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Configm email.
         * @param {ConfirmEmailCommand} [confirmEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ProfilesConfirmemailPost(confirmEmailCommand?: ConfirmEmailCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ProfilesConfirmemailPost(confirmEmailCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get Profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ProfilesGet(options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ProfilesGet(options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create a Profile.
         * @param {CreateProfileCommand} [createProfileCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ProfilesPost(createProfileCommand?: CreateProfileCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ProfilesPost(createProfileCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete Profile.
         * @param {string} profileId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ProfilesProfileIdDelete(profileId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ProfilesProfileIdDelete(profileId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update Profile.
         * @param {UpdateProfileCommand} [updateProfileCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1ProfilesPut(updateProfileCommand?: UpdateProfileCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<UserModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1ProfilesPut(updateProfileCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * ProfilesApi - factory interface
 * @export
 */
export const ProfilesApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = ProfilesApiFp(configuration)
    return {
        /**
         * Sample request:        POST /api/v1/profiles/changeEmail      {          \"email\": \"user@example.com\"      }
         * @summary Change user\'s email on both Identity and Api.
         * @param {ChangeEmailCommand} [changeEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesChangeemailPost(changeEmailCommand?: ChangeEmailCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ProfilesChangeemailPost(changeEmailCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Configm email.
         * @param {ConfirmEmailCommand} [confirmEmailCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesConfirmemailPost(confirmEmailCommand?: ConfirmEmailCommand, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ProfilesConfirmemailPost(confirmEmailCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get Profile.
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesGet(options?: any): AxiosPromise<UserModel> {
            return localVarFp.apiV1ProfilesGet(options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create a Profile.
         * @param {CreateProfileCommand} [createProfileCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesPost(createProfileCommand?: CreateProfileCommand, options?: any): AxiosPromise<UserModel> {
            return localVarFp.apiV1ProfilesPost(createProfileCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete Profile.
         * @param {string} profileId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesProfileIdDelete(profileId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1ProfilesProfileIdDelete(profileId, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update Profile.
         * @param {UpdateProfileCommand} [updateProfileCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1ProfilesPut(updateProfileCommand?: UpdateProfileCommand, options?: any): AxiosPromise<UserModel> {
            return localVarFp.apiV1ProfilesPut(updateProfileCommand, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1ProfilesChangeemailPost operation in ProfilesApi.
 * @export
 * @interface ProfilesApiApiV1ProfilesChangeemailPostRequest
 */
export interface ProfilesApiApiV1ProfilesChangeemailPostRequest {
    /**
     * 
     * @type {ChangeEmailCommand}
     * @memberof ProfilesApiApiV1ProfilesChangeemailPost
     */
    readonly changeEmailCommand?: ChangeEmailCommand
}

/**
 * Request parameters for apiV1ProfilesConfirmemailPost operation in ProfilesApi.
 * @export
 * @interface ProfilesApiApiV1ProfilesConfirmemailPostRequest
 */
export interface ProfilesApiApiV1ProfilesConfirmemailPostRequest {
    /**
     * 
     * @type {ConfirmEmailCommand}
     * @memberof ProfilesApiApiV1ProfilesConfirmemailPost
     */
    readonly confirmEmailCommand?: ConfirmEmailCommand
}

/**
 * Request parameters for apiV1ProfilesPost operation in ProfilesApi.
 * @export
 * @interface ProfilesApiApiV1ProfilesPostRequest
 */
export interface ProfilesApiApiV1ProfilesPostRequest {
    /**
     * 
     * @type {CreateProfileCommand}
     * @memberof ProfilesApiApiV1ProfilesPost
     */
    readonly createProfileCommand?: CreateProfileCommand
}

/**
 * Request parameters for apiV1ProfilesProfileIdDelete operation in ProfilesApi.
 * @export
 * @interface ProfilesApiApiV1ProfilesProfileIdDeleteRequest
 */
export interface ProfilesApiApiV1ProfilesProfileIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof ProfilesApiApiV1ProfilesProfileIdDelete
     */
    readonly profileId: string
}

/**
 * Request parameters for apiV1ProfilesPut operation in ProfilesApi.
 * @export
 * @interface ProfilesApiApiV1ProfilesPutRequest
 */
export interface ProfilesApiApiV1ProfilesPutRequest {
    /**
     * 
     * @type {UpdateProfileCommand}
     * @memberof ProfilesApiApiV1ProfilesPut
     */
    readonly updateProfileCommand?: UpdateProfileCommand
}

/**
 * ProfilesApi - object-oriented interface
 * @export
 * @class ProfilesApi
 * @extends {BaseAPI}
 */
export class ProfilesApi extends BaseAPI {
    /**
     * Sample request:        POST /api/v1/profiles/changeEmail      {          \"email\": \"user@example.com\"      }
     * @summary Change user\'s email on both Identity and Api.
     * @param {ProfilesApiApiV1ProfilesChangeemailPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProfilesApi
     */
    public apiV1ProfilesChangeemailPost(requestParameters: ProfilesApiApiV1ProfilesChangeemailPostRequest = {}, options?: AxiosRequestConfig) {
        return ProfilesApiFp(this.configuration).apiV1ProfilesChangeemailPost(requestParameters.changeEmailCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Configm email.
     * @param {ProfilesApiApiV1ProfilesConfirmemailPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProfilesApi
     */
    public apiV1ProfilesConfirmemailPost(requestParameters: ProfilesApiApiV1ProfilesConfirmemailPostRequest = {}, options?: AxiosRequestConfig) {
        return ProfilesApiFp(this.configuration).apiV1ProfilesConfirmemailPost(requestParameters.confirmEmailCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get Profile.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProfilesApi
     */
    public apiV1ProfilesGet(options?: AxiosRequestConfig) {
        return ProfilesApiFp(this.configuration).apiV1ProfilesGet(options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create a Profile.
     * @param {ProfilesApiApiV1ProfilesPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProfilesApi
     */
    public apiV1ProfilesPost(requestParameters: ProfilesApiApiV1ProfilesPostRequest = {}, options?: AxiosRequestConfig) {
        return ProfilesApiFp(this.configuration).apiV1ProfilesPost(requestParameters.createProfileCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete Profile.
     * @param {ProfilesApiApiV1ProfilesProfileIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProfilesApi
     */
    public apiV1ProfilesProfileIdDelete(requestParameters: ProfilesApiApiV1ProfilesProfileIdDeleteRequest, options?: AxiosRequestConfig) {
        return ProfilesApiFp(this.configuration).apiV1ProfilesProfileIdDelete(requestParameters.profileId, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update Profile.
     * @param {ProfilesApiApiV1ProfilesPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof ProfilesApi
     */
    public apiV1ProfilesPut(requestParameters: ProfilesApiApiV1ProfilesPutRequest = {}, options?: AxiosRequestConfig) {
        return ProfilesApiFp(this.configuration).apiV1ProfilesPut(requestParameters.updateProfileCommand, options).then((request) => request(this.axios, this.basePath));
    }
}
