/* tslint:disable */
/* eslint-disable */
/**
 * CloudHospital Admin Api
 * CloudHospital application with Swagger, Swashbuckle, and API versioning.
 *
 * The version of the OpenAPI document: 1
 * Contact: developer@icloudhospital.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */


import globalAxios, { AxiosPromise, AxiosInstance, AxiosRequestConfig } from 'axios';
import { Configuration } from '../configuration';
// Some imports not used depending on template conditions
// @ts-ignore
import { DUMMY_BASE_URL, assertParamExists, setApiKeyToObject, setBasicAuthToObject, setBearerAuthToObject, setOAuthToObject, setSearchParams, serializeDataIfNeeded, toPathString, createRequestFunction } from '../common';
// @ts-ignore
import { BASE_PATH, COLLECTION_FORMATS, RequestArgs, BaseAPI, RequiredError } from '../base';
// @ts-ignore
import { CreatePromotionCommand } from '../models';
// @ts-ignore
import { ProblemDetails } from '../models';
// @ts-ignore
import { PromotionModel } from '../models';
// @ts-ignore
import { PromotionType } from '../models';
// @ts-ignore
import { PromotionsModel } from '../models';
// @ts-ignore
import { UpdatePromotionCommand } from '../models';
/**
 * PromotionsApi - axios parameter creator
 * @export
 */
export const PromotionsApiAxiosParamCreator = function (configuration?: Configuration) {
    return {
        /**
         * 
         * @summary Get promotions
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {PromotionType} [promotionType] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [isActivated] 
         * @param {Date} [start] 
         * @param {Date} [end] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsGet: async (languageCode?: string, hospitalId?: string, promotionType?: PromotionType, showHidden?: boolean, isActivated?: boolean, start?: Date, end?: Date, page?: number, limit?: number, lastRetrieved?: Date, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/promotions`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['LanguageCode'] = languageCode;
            }

            if (hospitalId !== undefined) {
                localVarQueryParameter['HospitalId'] = hospitalId;
            }

            if (promotionType !== undefined) {
                localVarQueryParameter['PromotionType'] = promotionType;
            }

            if (showHidden !== undefined) {
                localVarQueryParameter['ShowHidden'] = showHidden;
            }

            if (isActivated !== undefined) {
                localVarQueryParameter['IsActivated'] = isActivated;
            }

            if (start !== undefined) {
                localVarQueryParameter['Start'] = (start as any instanceof Date) ?
                    (start as any).toISOString() :
                    start;
            }

            if (end !== undefined) {
                localVarQueryParameter['End'] = (end as any instanceof Date) ?
                    (end as any).toISOString() :
                    end;
            }

            if (page !== undefined) {
                localVarQueryParameter['page'] = page;
            }

            if (limit !== undefined) {
                localVarQueryParameter['limit'] = limit;
            }

            if (lastRetrieved !== undefined) {
                localVarQueryParameter['lastRetrieved'] = (lastRetrieved as any instanceof Date) ?
                    (lastRetrieved as any).toISOString() :
                    lastRetrieved;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Create promotion
         * @param {CreatePromotionCommand} [createPromotionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPost: async (createPromotionCommand?: CreatePromotionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            const localVarPath = `/api/v1/promotions`;
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'POST', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(createPromotionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Delete promotion
         * @param {string} promotionId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdDelete: async (promotionId: string, isPermanent?: boolean, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'promotionId' is not null or undefined
            assertParamExists('apiV1PromotionsPromotionIdDelete', 'promotionId', promotionId)
            const localVarPath = `/api/v1/promotions/{promotionId}`
                .replace(`{${"promotionId"}}`, encodeURIComponent(String(promotionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'DELETE', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (isPermanent !== undefined) {
                localVarQueryParameter['isPermanent'] = isPermanent;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Get promotion
         * @param {string} promotionId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdGet: async (promotionId: string, languageCode?: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'promotionId' is not null or undefined
            assertParamExists('apiV1PromotionsPromotionIdGet', 'promotionId', promotionId)
            const localVarPath = `/api/v1/promotions/{promotionId}`
                .replace(`{${"promotionId"}}`, encodeURIComponent(String(promotionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'GET', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)

            if (languageCode !== undefined) {
                localVarQueryParameter['languageCode'] = languageCode;
            }


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Update promotion
         * @param {string} promotionId 
         * @param {UpdatePromotionCommand} [updatePromotionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdPut: async (promotionId: string, updatePromotionCommand?: UpdatePromotionCommand, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'promotionId' is not null or undefined
            assertParamExists('apiV1PromotionsPromotionIdPut', 'promotionId', promotionId)
            const localVarPath = `/api/v1/promotions/{promotionId}`
                .replace(`{${"promotionId"}}`, encodeURIComponent(String(promotionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            localVarHeaderParameter['Content-Type'] = 'application/json';

            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};
            localVarRequestOptions.data = serializeDataIfNeeded(updatePromotionCommand, localVarRequestOptions, configuration)

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
        /**
         * 
         * @summary Reactivate promotion
         * @param {string} promotionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdReactivatePut: async (promotionId: string, options: AxiosRequestConfig = {}): Promise<RequestArgs> => {
            // verify required parameter 'promotionId' is not null or undefined
            assertParamExists('apiV1PromotionsPromotionIdReactivatePut', 'promotionId', promotionId)
            const localVarPath = `/api/v1/promotions/{promotionId}/reactivate`
                .replace(`{${"promotionId"}}`, encodeURIComponent(String(promotionId)));
            // use dummy base URL string because the URL constructor only accepts absolute URLs.
            const localVarUrlObj = new URL(localVarPath, DUMMY_BASE_URL);
            let baseOptions;
            if (configuration) {
                baseOptions = configuration.baseOptions;
            }

            const localVarRequestOptions = { method: 'PUT', ...baseOptions, ...options};
            const localVarHeaderParameter = {} as any;
            const localVarQueryParameter = {} as any;

            // authentication oauth2 required
            // oauth required
            await setOAuthToObject(localVarHeaderParameter, "oauth2", ["cloudhospital_admin_api"], configuration)


    
            setSearchParams(localVarUrlObj, localVarQueryParameter);
            let headersFromBaseOptions = baseOptions && baseOptions.headers ? baseOptions.headers : {};
            localVarRequestOptions.headers = {...localVarHeaderParameter, ...headersFromBaseOptions, ...options.headers};

            return {
                url: toPathString(localVarUrlObj),
                options: localVarRequestOptions,
            };
        },
    }
};

/**
 * PromotionsApi - functional programming interface
 * @export
 */
export const PromotionsApiFp = function(configuration?: Configuration) {
    const localVarAxiosParamCreator = PromotionsApiAxiosParamCreator(configuration)
    return {
        /**
         * 
         * @summary Get promotions
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {PromotionType} [promotionType] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [isActivated] 
         * @param {Date} [start] 
         * @param {Date} [end] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PromotionsGet(languageCode?: string, hospitalId?: string, promotionType?: PromotionType, showHidden?: boolean, isActivated?: boolean, start?: Date, end?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionsModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PromotionsGet(languageCode, hospitalId, promotionType, showHidden, isActivated, start, end, page, limit, lastRetrieved, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Create promotion
         * @param {CreatePromotionCommand} [createPromotionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PromotionsPost(createPromotionCommand?: CreatePromotionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PromotionsPost(createPromotionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Delete promotion
         * @param {string} promotionId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PromotionsPromotionIdDelete(promotionId: string, isPermanent?: boolean, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PromotionsPromotionIdDelete(promotionId, isPermanent, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Get promotion
         * @param {string} promotionId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PromotionsPromotionIdGet(promotionId: string, languageCode?: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PromotionsPromotionIdGet(promotionId, languageCode, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Update promotion
         * @param {string} promotionId 
         * @param {UpdatePromotionCommand} [updatePromotionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PromotionsPromotionIdPut(promotionId: string, updatePromotionCommand?: UpdatePromotionCommand, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<PromotionModel>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PromotionsPromotionIdPut(promotionId, updatePromotionCommand, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
        /**
         * 
         * @summary Reactivate promotion
         * @param {string} promotionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        async apiV1PromotionsPromotionIdReactivatePut(promotionId: string, options?: AxiosRequestConfig): Promise<(axios?: AxiosInstance, basePath?: string) => AxiosPromise<boolean>> {
            const localVarAxiosArgs = await localVarAxiosParamCreator.apiV1PromotionsPromotionIdReactivatePut(promotionId, options);
            return createRequestFunction(localVarAxiosArgs, globalAxios, BASE_PATH, configuration);
        },
    }
};

/**
 * PromotionsApi - factory interface
 * @export
 */
export const PromotionsApiFactory = function (configuration?: Configuration, basePath?: string, axios?: AxiosInstance) {
    const localVarFp = PromotionsApiFp(configuration)
    return {
        /**
         * 
         * @summary Get promotions
         * @param {string} [languageCode] 
         * @param {string} [hospitalId] 
         * @param {PromotionType} [promotionType] 
         * @param {boolean} [showHidden] 
         * @param {boolean} [isActivated] 
         * @param {Date} [start] 
         * @param {Date} [end] 
         * @param {number} [page] 
         * @param {number} [limit] 
         * @param {Date} [lastRetrieved] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsGet(languageCode?: string, hospitalId?: string, promotionType?: PromotionType, showHidden?: boolean, isActivated?: boolean, start?: Date, end?: Date, page?: number, limit?: number, lastRetrieved?: Date, options?: any): AxiosPromise<PromotionsModel> {
            return localVarFp.apiV1PromotionsGet(languageCode, hospitalId, promotionType, showHidden, isActivated, start, end, page, limit, lastRetrieved, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Create promotion
         * @param {CreatePromotionCommand} [createPromotionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPost(createPromotionCommand?: CreatePromotionCommand, options?: any): AxiosPromise<PromotionModel> {
            return localVarFp.apiV1PromotionsPost(createPromotionCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Delete promotion
         * @param {string} promotionId 
         * @param {boolean} [isPermanent] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdDelete(promotionId: string, isPermanent?: boolean, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PromotionsPromotionIdDelete(promotionId, isPermanent, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Get promotion
         * @param {string} promotionId 
         * @param {string} [languageCode] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdGet(promotionId: string, languageCode?: string, options?: any): AxiosPromise<PromotionModel> {
            return localVarFp.apiV1PromotionsPromotionIdGet(promotionId, languageCode, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Update promotion
         * @param {string} promotionId 
         * @param {UpdatePromotionCommand} [updatePromotionCommand] 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdPut(promotionId: string, updatePromotionCommand?: UpdatePromotionCommand, options?: any): AxiosPromise<PromotionModel> {
            return localVarFp.apiV1PromotionsPromotionIdPut(promotionId, updatePromotionCommand, options).then((request) => request(axios, basePath));
        },
        /**
         * 
         * @summary Reactivate promotion
         * @param {string} promotionId 
         * @param {*} [options] Override http request option.
         * @throws {RequiredError}
         */
        apiV1PromotionsPromotionIdReactivatePut(promotionId: string, options?: any): AxiosPromise<boolean> {
            return localVarFp.apiV1PromotionsPromotionIdReactivatePut(promotionId, options).then((request) => request(axios, basePath));
        },
    };
};

/**
 * Request parameters for apiV1PromotionsGet operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsGetRequest
 */
export interface PromotionsApiApiV1PromotionsGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly languageCode?: string

    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly hospitalId?: string

    /**
     * 
     * @type {PromotionType}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly promotionType?: PromotionType

    /**
     * 
     * @type {boolean}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly showHidden?: boolean

    /**
     * 
     * @type {boolean}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly isActivated?: boolean

    /**
     * 
     * @type {Date}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly start?: Date

    /**
     * 
     * @type {Date}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly end?: Date

    /**
     * 
     * @type {number}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly page?: number

    /**
     * 
     * @type {number}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly limit?: number

    /**
     * 
     * @type {Date}
     * @memberof PromotionsApiApiV1PromotionsGet
     */
    readonly lastRetrieved?: Date
}

/**
 * Request parameters for apiV1PromotionsPost operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPostRequest
 */
export interface PromotionsApiApiV1PromotionsPostRequest {
    /**
     * 
     * @type {CreatePromotionCommand}
     * @memberof PromotionsApiApiV1PromotionsPost
     */
    readonly createPromotionCommand?: CreatePromotionCommand
}

/**
 * Request parameters for apiV1PromotionsPromotionIdDelete operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdDeleteRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdDeleteRequest {
    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdDelete
     */
    readonly promotionId: string

    /**
     * 
     * @type {boolean}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdDelete
     */
    readonly isPermanent?: boolean
}

/**
 * Request parameters for apiV1PromotionsPromotionIdGet operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdGetRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdGetRequest {
    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdGet
     */
    readonly promotionId: string

    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdGet
     */
    readonly languageCode?: string
}

/**
 * Request parameters for apiV1PromotionsPromotionIdPut operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdPutRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdPutRequest {
    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdPut
     */
    readonly promotionId: string

    /**
     * 
     * @type {UpdatePromotionCommand}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdPut
     */
    readonly updatePromotionCommand?: UpdatePromotionCommand
}

/**
 * Request parameters for apiV1PromotionsPromotionIdReactivatePut operation in PromotionsApi.
 * @export
 * @interface PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest
 */
export interface PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest {
    /**
     * 
     * @type {string}
     * @memberof PromotionsApiApiV1PromotionsPromotionIdReactivatePut
     */
    readonly promotionId: string
}

/**
 * PromotionsApi - object-oriented interface
 * @export
 * @class PromotionsApi
 * @extends {BaseAPI}
 */
export class PromotionsApi extends BaseAPI {
    /**
     * 
     * @summary Get promotions
     * @param {PromotionsApiApiV1PromotionsGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    public apiV1PromotionsGet(requestParameters: PromotionsApiApiV1PromotionsGetRequest = {}, options?: AxiosRequestConfig) {
        return PromotionsApiFp(this.configuration).apiV1PromotionsGet(requestParameters.languageCode, requestParameters.hospitalId, requestParameters.promotionType, requestParameters.showHidden, requestParameters.isActivated, requestParameters.start, requestParameters.end, requestParameters.page, requestParameters.limit, requestParameters.lastRetrieved, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Create promotion
     * @param {PromotionsApiApiV1PromotionsPostRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    public apiV1PromotionsPost(requestParameters: PromotionsApiApiV1PromotionsPostRequest = {}, options?: AxiosRequestConfig) {
        return PromotionsApiFp(this.configuration).apiV1PromotionsPost(requestParameters.createPromotionCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Delete promotion
     * @param {PromotionsApiApiV1PromotionsPromotionIdDeleteRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    public apiV1PromotionsPromotionIdDelete(requestParameters: PromotionsApiApiV1PromotionsPromotionIdDeleteRequest, options?: AxiosRequestConfig) {
        return PromotionsApiFp(this.configuration).apiV1PromotionsPromotionIdDelete(requestParameters.promotionId, requestParameters.isPermanent, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Get promotion
     * @param {PromotionsApiApiV1PromotionsPromotionIdGetRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    public apiV1PromotionsPromotionIdGet(requestParameters: PromotionsApiApiV1PromotionsPromotionIdGetRequest, options?: AxiosRequestConfig) {
        return PromotionsApiFp(this.configuration).apiV1PromotionsPromotionIdGet(requestParameters.promotionId, requestParameters.languageCode, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Update promotion
     * @param {PromotionsApiApiV1PromotionsPromotionIdPutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    public apiV1PromotionsPromotionIdPut(requestParameters: PromotionsApiApiV1PromotionsPromotionIdPutRequest, options?: AxiosRequestConfig) {
        return PromotionsApiFp(this.configuration).apiV1PromotionsPromotionIdPut(requestParameters.promotionId, requestParameters.updatePromotionCommand, options).then((request) => request(this.axios, this.basePath));
    }

    /**
     * 
     * @summary Reactivate promotion
     * @param {PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest} requestParameters Request parameters.
     * @param {*} [options] Override http request option.
     * @throws {RequiredError}
     * @memberof PromotionsApi
     */
    public apiV1PromotionsPromotionIdReactivatePut(requestParameters: PromotionsApiApiV1PromotionsPromotionIdReactivatePutRequest, options?: AxiosRequestConfig) {
        return PromotionsApiFp(this.configuration).apiV1PromotionsPromotionIdReactivatePut(requestParameters.promotionId, options).then((request) => request(this.axios, this.basePath));
    }
}
